// jpnslisp.cpp

#include "jpnslisp.h"

char lineStr[BUFLEN];

CELL *cl,*curCl;
long FreeCellSize;
long FreeNumberSize;
long FreeIntSize;
char *strArea,*curStr;
CELL **strAreaAddr,**curStrAddr;
AFLOAT *nArea,*curN;
AINT *iArea,*curI;
SYMVAL *sv,*curSv;
SYMVAL *fv,*curFv;
//char *mojiretsuArea,*curMojiretsu;

CELL **CellStack,**curCellStack;
SYMVAL **LocStack,**curLocStack;
SYMVAL **StaticStack,**curStaticStack;  // N[Wp
BOOL GetToEndCell = FALSE;

CELL *NILCell,*TCell;
CELL *QUOTE,*CAR,*CDR,*CONS,*PRINT,*PRIN1,*SET,*NIL,*T;
CELL *BACKQUOTE,*BACK_QUOTE,*COMMA,*AST;
CELL *DEFUN,*AMPREST,*LET,*LETAST,*SETQ,*PROG,*GO,*RETURN;
CELL *AND,*OR,*ONEPLUS,*ONEMINUS,*COND,*NUMBEREQUAL,*DEFMACRO,*AMPBODY;
CELL *ATOM,*LIST,*EQ,*EVAL,*NULLP,*PROGN,*IF,*TREAD,*TOPEN,*COLDIRECTION,*COLINPUT,*COLOUTPUT;
CELL *TCLOSE,*PROG1,*PLUS,*MINUS,*MINUSP,*EQL,*CHAR,*STRINGP,*LENGTH,*COERCE,*STRING,*PRINC;
CELL *FUNCTION,*LAMBDA,*SPACES,*TERPRI,*STRINGEQUAL,*READLINE,*GC,*BYE,*QUIT,*EXIT,*DEFPARAMETER;
CELL *DEFVAR,*CONSP,*NUMBERP,*TIMES,*DIVIDE,*VALUES,*MULTIPLEVALUELIST,*EVAL1,*APPLY,*FUNCALL;
CELL *RPLACA,*RPLACD,*SYMBOLP,*CHARACTERP,*CHAREQUAL,*CHARLESS,*MACROEXPAND;
CELL *INTEGERP,*SETARRAY,*CHARACTER,*ARRAYCAR,*ARRAYCDR,*ARRAYP,*RANDOM;
CELL *SQRT,*EXPT,*EXP,*LOG,*SIN,*COS,*TAN,*ASIN,*ACOS,*ATAN;
CELL *EVENP,*FLOOR;

CELL *ReturnValue,*GoSymbol;

char ReturnFlag;

FILE *FilePointer[FILE_POINTER_LEN];

char *ReadEvalData[READ_EVAL_NUM] = {
    "(setq pi 3.14159265358979)",
    "(defun oddp (n) (cond ((evenp n) nil) (t t)))",
    "(defun append1 (x y) (cond ((atom x) y) (t (cons (car x) (append1 (cdr x) y)))))",
    "(defmacro loop1 (&rest b) (append1 (append1 (list 'prog '() 'label) b) (list '(go label)))))",
    "(defmacro loop (&rest b)"
        "(cond ((and (eq 'for (car b)) (eq 'below (car (cdr (cdr b)))))"
               "(append1 (list 'prog"
                             "(list (car (cdr b)))"
                             "(list 'setq (car (cdr b)) 0)"
			     "'label"
                             "(list 'cond (list (list '= (car (cdr b)) (eval (car (cdr (cdr (cdr b)))))) '(return))) )"
                       "(append1 (cdr (cdr (cdr (cdr (cdr  b)))))"
                               "(append1 (list (list 'setq (car (cdr b)) (list '1+ (car (cdr b)))))"
                                       "(list '(go label)) ) ) ) )"
              "(t (cons 'loop1 b))))",
    "(defmacro dolist (&rest b)"
	"(append1"
	    "(list 'prog `(,(car (car b)))"
		"`(setq list ,(car (cdr (car b))))"
		" 'label "
                " `(if (null list) (setq ,(car (car b)) nil))"
		" `(if (null list) ,(list 'return (cond ((null (cdr (cdr (car b)))) nil) (t (car (cdr (cdr (car b))))))))"
                " `(setq ,(car (car b)) (car list))"
	    ")"
	    "(append1 (cdr b) (list '(setq list (cdr list)) '(go label))) ) )",
    "(defmacro dotimes (&rest b)"
	"`(prog (,(car (car b)))"
	    "(setq ,(car (car b)) 0)"
	    " label "
	    "(if (= ,(car (car b)) ,(car (cdr (car b))))"
                "(return ,(cond ((null (cdr (cdr (car b)))) nil) (t (car (cdr (cdr (car b))))))) )"
            ",@(cdr b)"
                "(setq ,(car (car b)) (1+ ,(car (car b))))"
            "(go label) ) )",
    "(defun load (fname)"
	"(let ((strm) (s))"
	    "(setq strm (open fname))"
	    "(if (null strm) nil"
	        "(loop1 "
		    "(if (null (setq s (read strm nil))) (progn (close strm) (return t)))"
		    "(eval s) ) ) ) )",
    "(defmacro with-open-file (a &rest b)"
	"`(let ((,(car a) (open ,@(cdr a))))"
	    "(if (null ,(car a)) nil "
		"(prog1 "
		    "(progn "
			",@b)"
		    "(close ,(car a)) ) ) ) )",
    "(defun not (e) (cond ((null e) t) (t nil)))",
    "(defun zerop (x) (cond ((= x 0) t) (t nil)))",
    "(defun listp (x) (cond ((null x) t) ((not (atom x)) t) (t nil)))",
    "(defun > (x y) (cond ((minusp (- x y)) nil) ((zerop (- x y)) nil) (t t)))",
    "(defun >= (x y) (cond ((minusp (- x y)) nil) (t t)))",
    "(defun < (x y) (cond ((minusp (- x y)) t) (t nil)))",
    "(defun <= (x y) (cond ((minusp (- x y)) t) ((zerop (- x y)) t) (t nil)))",
    "(defun equal (x y)"
	"(if (atom x) (eql x y)"
	    "(if (atom y) nil"
		"(if (equal (car x) (car y))"
		    "(equal (cdr x) (cdr y))"
		    "nil ) ) ) )",
    "(defun subseq (x m &rest n)"
	"(let ((ans nil) (len) (k (if (atom n) nil (car n))))"
	    "(cond"
	        "((stringp x)"
	         "(cond"
		    "((null k) (setq len (length x))"
		     "(loop"
			"(if (= m len) (return (coerce ans 'string)))"
			"(setq ans (append ans (list (char x m))))"
			"(setq m (1+ m)) ) )"
		    "(t"
		     "(loop"
			"(if (= m k) (return (coerce ans 'string)))"
			"(setq ans (append ans (list (char x m))))"
			"(setq m (1+ m)) ) ) ) )"
	        "(t"
	         "(cond"
		    "((null k) (setq len (length x))"
		     "(loop"
			"(if (= m len) (return ans))"
			"(setq ans (append ans (list (nth m x))))"
			"(setq m (1+ m)) ) )"
		    "(t"
		     "(loop"
			"(if (= m k) (return ans))"
			"(setq ans (append ans (list (nth m x))))"
			"(setq m (1+ m)) ) ) ) ) ) ) )",
    "(defun nth (n lst)"
	"(let ((k 0))"
	    "(loop"
	        "(if (= k n) (return (car lst)))"
	        "(setq lst (cdr lst))"
	        "(setq k (1+ k)) ) ) )",

    "(defun pprint (x)"
        "(pprint2 x 0)"
        "(terpri)"
        " t )",

    "(defun pprint2 (x n)"
        "(cond"
            "((atom x) (spaces n) (prin1 x))"
            "((is-all-atom-1-list x) (spaces n) (prin1 x))"
            "(t"
             "(spaces n)"
             "(princ #\\()"
             "(pprint3 (car x) (+ n 1))"
             "(setq x (cdr x))"
             "(loop"
                 "(if (atom x) (return))"
                 "(terpri)"
                 "(pprint2 (car x) (+ n 1))"
                 "(setq x (cdr x)) )"
             "(princ #\\)) ) ) )",

    "(defun pprint3 (x n)"
        "(cond"
            "((atom x) (prin1 x))"
            "((is-all-atom-1-list x) (prin1 x))"
            "(t"
             "(princ #\\()"
             "(pprint3 (car x) (+ n 1))"
             "(setq x (cdr x))"
             "(loop"
                 "(if (atom x) (return))"
                 "(terpri)"
                 "(pprint2 (car x) (+ n 1))"
                 "(setq x (cdr x)) )"
         "(princ #\\)) ) ) )",

    "(defun is-all-atom (x)"
        "(loop"
            "(if (atom x) (return t))"
            "(if (not (atom (car x))) (return nil))"
            "(setq x (cdr x)) ) )",

    "(defun is-all-atom-1-list (x)"
        "(loop"
            "(if (atom x) (return t))"
            "(if (and (not (atom (car x))) (not (is-all-atom (car x)))) (return nil))"
            "(setq x (cdr x)) ) )",

    "(defmacro append (&rest l)"
        "(cond"
	    "((null l) nil)"
	    "((null (cdr l)) (car l))"
	    "(t (list 'append1 (car l)"
		    "(cons 'append (cdr l)) ) ) ) )",

    "(defun reverse (x)"
	"(cond"
	    "((stringp x) (coerce (reverse1 (coerce x 'list)) 'string)) "
	    "(t (reverse1 x)) ) )",

    "(defun reverse1 (x)"
	"(cond"
	    "((atom x) x)"
	    "(t (append (reverse (cdr x)) (cons (car x) nil))) ) )",

    "(defun multiple-value-born$ (arg value)"
        "(cond"
	    "((null arg) nil)"
	    "((null value) (cons (list 'setq (car arg) 'nil) (multiple-value-born$ (cdr arg) value)))"
	    "(t (cons (list 'setq (car arg) (list 'quote (car value))) (multiple-value-born$ (cdr arg) (cdr value)))) ) )",

    "(defmacro multiple-value-setq (a b) `(multiple-value-setq$ ,a ,(multiple-value-list (eval1 b))))",

    "(defmacro multiple-value-setq$ (a b) `(prog1 ,@(multiple-value-born$ a b)))",

    "(defmacro multiple-value-bind (a b &rest c) `(let ,(mapcar #'list a) (multiple-value-setq ,a ,b) ,@c))",

//    "(defun funcall (x &rest y) (apply x y))",

    "(defun mapcar (func a &rest b)"
        "(cond"
	    "((atom a) nil)"
	    "((and (not (atom b)) (atom (car b))) nil)"
	    "((atom b) (cons"
                         "(funcall func (car a))"
                         "(mapcar func (cdr a)) ) )"
            "(t (cons (apply func (cons (car a) (list (car (car b)))))"
		     "(mapcar func (cdr a) (cdr (car b))) ) ) ) )",

    "(defun member (item lst &rest a)"
        "(let ((test (if (and (not (null a))"
                             "(eq :test (car a))"
			     "(not (atom (cdr a))) )"
		        "(car (cdr a))"
		    "#'eql) ) )"
	    "(if (null lst) nil"
	        "(if (funcall test item (car lst)) lst"
		    "(member item (cdr lst) :test test)))))",

    "(defun first (x) (car x))",

    "(defun rest (x) (cdr x))",

    "(defun char= (x y) (char-equal x y))",

    "(defun char/= (x y) (not (char-equal x y)))",

    "(defun char> (x y) (char< y x))",

    "(defun char<= (x y) (or (char< x y) (char= x y)))",

    "(defun char>= (x y) (or (char> x y) (char= x y)))",

//    "(defmacro prog1 (&rest b)"
//	"(cond ((null b) nil)"
//	    "(t `(let ((#:value ,(car b))) ,@(cdr b) #:value)) ) )"

    "(defmacro lambda (&rest b) `(function (lambda ,@b)))"

};

CELL *IncCellStack(CELL *c)
{
	if (curCellStack - CellStack >= CELL_STACK_SIZE - 1) {
		printf("G[: ZX^bNtłBI܂\n");
		exit(1);
		return NULL;
	}
	*curCellStack++ = c;
	return c;
}

int IncLocStack(SYMVAL *loc,long len)
{
	long i;

    	if (curLocStack - LocStack >= LOC_STACK_SIZE - 1) {
	    	printf("G[: [JX^bNtłBI܂\n");
		exit(1);
		return -1;
	}
	*curLocStack++ = NULL;
//	loc++;
	for (i = 0;i < len;i++) {
    	    if (curLocStack - LocStack >= LOC_STACK_SIZE - 1) {
	    	printf("G[: [JX^bNtłBI܂\n");
		exit(1);
		return -1;
	    }
	    *curLocStack++ = loc;
	    loc++;
	}
	return 0;
}

void IncStaticStack(SYMVAL *loc,long len)
{
	long i;

    	if (curStaticStack - StaticStack >= STATIC_STACK_SIZE - 1) {
	    	printf("G[: X^eBbNX^bNtłBI܂\n");
		exit(1);
	}
	*curStaticStack++ = NULL;
	for (i = 0;i < len;i++) {
    	    if (curStaticStack - StaticStack >= STATIC_STACK_SIZE - 1) {
	    	printf("G[: X^eBbNX^bNtłBI܂\n");
		exit(1);
	    }
	    *curStaticStack++ = loc;
	    loc++;
	}
}

void PopCellStack(void)
{
    while (*(--curCellStack) != NULL);
}

void PopLocStack(void)
{
    while (*(--curLocStack) != NULL);
}

#if 0
void SetOrgLoc(SYMVAL *orgloc,long orglen,SYMVAL *temploc,long start,long newlen)
{
    long i,j;

    for (i = start;i < newlen;i++) {
	if (temploc[i].sym != NULL) {
	    for (j = 0;j < orglen;j++) {
		if (orgloc[j].sym != NULL) {
		    if (orgloc[j].sym == temploc[i].sym) {
			orgloc[j].attr = temploc[i].attr;
			orgloc[j].val = temploc[i].val;
			break;
		    }
		}
	    }
	}
    }
}
#else
void SetOrgLoc(SYMVAL *orgloc,long orglen,SYMVAL *temploc,long start,long newlen)
{
    long i,j;

    for (i = newlen - 1;!(i < start);i--) {
	if (temploc[i].sym != NULL) {
	    for (j = 0;j < orglen;j++) {
		if (orgloc[j].sym != NULL) {
		    if (orgloc[j].sym == temploc[i].sym) {
			orgloc[j].attr = temploc[i].attr;
			orgloc[j].val = temploc[i].val;
			break;
		    }
		}
	    }
	}
    }
}
#endif

/*
void writeMojiretsuD(char *p)
{
    while (*p != '\0') p++;
    p++;
    *p = 'd';
}
*/

/*
void Disable(CELL *p)
{
	if (p->attr == 's') {
		p->gc = 'd';
		if (p->mtop != NULL) Disable(p->mtop);
	}
	else if (p->attr == 'i') {
		p->gc = 'd';
		((AINT *)(p->car))->gc = 'd';
		if (p->mtop != NULL) Disable(p->mtop);
	}
	else if (p->attr == 'n') {
		p->gc = 'd';
		((AFLOAT *)(p->car))->gc = 'd';
		if (p->mtop != NULL) Disable(p->mtop);
	}
	else if (p->attr == 'b') {
		p->gc = 'd';
		((AINT *)(p->car))->gc = 'd';
		((AINT *)(p->cdr))->gc = 'd';
		if (p->mtop != NULL) Disable(p->mtop);
	}
	else if (p->attr == 'r') {
		p->gc = 'd';
		writeMojiretsuD((char *)(p->car));
		if (p->mtop != NULL) Disable(p->mtop);
	}
	else if (p->attr == 'm') {
		p->gc = 'd';
		if (p->mtop != NULL) Disable(p->mtop);
	}
	else if (p->attr == 'l' && p->gc != 'd') {
		p->gc = 'd';
		Disable(p->car);
		Disable(p->cdr);
		if (p->mtop != NULL) Disable(p->mtop);
	}
	else if (p->attr == 'a' && p->gc != 'd') {
		p->gc = 'd';
		Disable(p->car);
		Disable(p->cdr);
		if (p->mtop != NULL) Disable(p->mtop);
	}
}
*/

void Disable(CELL *p)
{
	if (p->attr == 's') {
		p->gc = 'd';
		if (p->mtop != NULL) { (p->mtop)->gc = 'd'; if (((p->mtop)->cdr)->attr == 'l') Disable((p->mtop)->cdr); }
	}
	else if (p->attr == 'i') {
		p->gc = 'd';
		((AINT *)(p->car))->gc = 'd'; // mtop̏uDisableŃ[vȂ悤ɁB
		if (p->mtop != NULL) { (p->mtop)->gc = 'd'; if (((p->mtop)->cdr)->attr == 'l') Disable((p->mtop)->cdr); } //Disable(p->mtop);
	}
	else if (p->attr == 'n') {
		p->gc = 'd';
		((AFLOAT *)(p->car))->gc = 'd';
		if (p->mtop != NULL) { (p->mtop)->gc = 'd'; if (((p->mtop)->cdr)->attr == 'l') Disable((p->mtop)->cdr); } //Disable(p->mtop);
	}
	else if (p->attr == 'b') {
		p->gc = 'd';
		((AINT *)(p->car))->gc = 'd';
		((AINT *)(p->cdr))->gc = 'd';
		if (p->mtop != NULL) { (p->mtop)->gc = 'd'; if (((p->mtop)->cdr)->attr == 'l') Disable((p->mtop)->cdr); } //Disable(p->mtop);
	}
	else if (p->attr == 'm') {
		p->gc = 'd';
		if (p->mtop != NULL) { (p->mtop)->gc = 'd'; if (((p->mtop)->cdr)->attr == 'l') Disable((p->mtop)->cdr); } //Disable(p->mtop);
	}
	else if (p->attr == 'l' && p->gc != 'd') {
		p->gc = 'd';
		Disable(p->car);
		Disable(p->cdr);
		if (p->mtop != NULL) { (p->mtop)->gc = 'd'; if (((p->mtop)->cdr)->attr == 'l') Disable((p->mtop)->cdr); } //Disable(p->mtop);
	}
	else if (p->attr == 'a' && p->gc != 'd') {
		p->gc = 'd';
		Disable(p->car);
		Disable(p->cdr);
		if (p->mtop != NULL) { (p->mtop)->gc = 'd'; if (((p->mtop)->cdr)->attr == 'l') Disable((p->mtop)->cdr); } //Disable(p->mtop);
	}
}

/*
void initMojiretsuForGc(void)
{
    char *p,*endp;

    p = mojiretsuArea;
    endp = mojiretsuArea + MOJIRETSU_SIZE - 2;
    while (p < endp) {
	if (*p == '\0') {
	    p++;
	}
	else {
	    while (*p != '\0') p++;
	    p++;
	    *p++ = 'e';
	}
    }
}
*/

/*
void RecoverMojiretsu(void)
{
    char *p,*endp,*q;

    p = mojiretsuArea;
    endp = mojiretsuArea + MOJIRETSU_SIZE - 2;
    while (p < endp) {
	if (*p == '\0') {
	    p++;
	}
	else {
	    q = p;
	    while (*q != '\0') q++;
	    q++;
	    if (*q == 'd') { p = q; p++; }
	    else {
		while (*p != '\0') *p++ = '\0';
		p++;
		*p++ = '\0';
	    }
	}
    }
    curMojiretsu = mojiretsuArea;
}
*/

void gc(void)
{
	CELL *p;
	CELL **q;
	SYMVAL **r;
	AFLOAT *a;
	SYMVAL *b;
        long k = 0,k2 = 0,k3 = 0,i;
	char c;
	AINT *q2;

	p = cl;
	for (i = 0;i < CELL_SIZE;i++) {
		if (p->attr != 's') p->gc = 'e';
		p++;
	}
	a = nArea;
	for (i = 0;i < NUMBER_SIZE;i++) {
		a->gc = 'e';
	    a++;
	}
	q2 = iArea;
	for (i = 0;i < INT_SIZE;i++) {
		q2->gc = 'e';
		q2++;
	}
//	initMojiretsuForGc();
	q = CellStack;
	while (q != curCellStack) {
		if (*q != NULL) {
			Disable(*q);
		}
		q++;
	}
	r = LocStack;
//printf("len = %ld\n",curLocStack - LocStack);
	while (r != curLocStack) {
		if (*r != NULL && (*r)->sym != NULL) {
//printf("%x ",(*r)->sym);
			Disable((*r)->val);
		}
		r++;
	}
	r = StaticStack;
	while (r != curStaticStack) {
		if (*r != NULL && (*r)->sym != NULL) {
//printf("%x ",(*r)->sym);
			Disable((*r)->val);
		}
		r++;
	}
	b = sv;
	while (b != curSv) {
                Disable(b->val);
		b++;
	}
	b = fv;  // Add
	while (b != curFv) {
                Disable(b->val);
		b++;
	}
	p = cl;
	for (i = 0;i < CELL_SIZE;i++) {
		if (p->gc == 'd') k++;
		p++;
	}
	a = nArea;
	for (i = 0;i < NUMBER_SIZE;i++) {
		if (a->gc == 'd') k2++;
	    a++;
	}
	q2 = iArea;
	for (i = 0;i < INT_SIZE;i++) {
		if (q2->gc == 'd') k3++;
	    q2++;
	}
//	RecoverMojiretsu();
	if (GetToEndCell) c = '*';
	else c = ' ';
	FreeCellSize = CELL_SIZE - k;
	FreeNumberSize = NUMBER_SIZE - k2;
	FreeIntSize = INT_SIZE - k3;
	printf("gc: gp̃Z %ld gp̕_̐ %ld gp̐̐ %ld %c\n",k,k2,k3,c);
}

CELL *getCell(void)
{
	CELL *p;
	long i;

	for (i = 0;i < CELL_SIZE - 1;i++) {
	    if (curCl->gc == 'e') {
		p = curCl++;
                if (curCl == cl + CELL_SIZE - 1) {
			curCl = cl;
			GetToEndCell = TRUE;
	        }
                p->gc = 'd';
	        FreeCellSize--;
                p->mtop = NULL;  // Add.
		p->clj = NULL;
		p->cljlen = 0L;

		// 2015/2/24 ȉ4sǉBftH[g̒lBꂪȂƋ̃ZvꂽK[x[WRNVɖ\B
		p->attr = 'l';
		p->attr2 = 'u';
		p->car = NILCell;
		p->cdr = NILCell;

/* Deleted in Apr.2016
		IncCellStack(p);  // ŃZX^bNςނƁigcpj
*/
	        return p;
	    }
	    curCl++;
            if (curCl == cl + CELL_SIZE - 1) {
			curCl = cl;
			GetToEndCell = TRUE;
	    }
	}
        printf("G[: Z̈悪tłBI܂B\n");
	exit(1);
	return NULL;
}

int isKanji(unsigned char *str)
{
	if (((unsigned char)0x81 <= *str && *str <= (unsigned char)0x9f) ||
		((unsigned char)0xe0 <= *str && *str <= (unsigned char)0xfc) ) {
		return 1;
	}
	return 0;
}

CELL *getMojiCell(char c1,  // A܂̓VtgihrR[hPoCg
		  char c2 ) // VtgihrR[hQoCg
{
    CELL *p;

    if ((p = getCell()) == NULL) return NULL;
    p->attr = 'm';
    p->car = (CELL *)c1;
    if (isKanji(&c1)) {
	p->cdr = (CELL *)c2;
    }
    else p->cdr = NULL;
    return p;
}

// 2̍ő񐔂Ƃ߂B
long gcd(long x,long y)
{
    long temp,oy;

    if (!(x > y)) { temp  = x; x = y; y = temp; }
    oy = y;
    while (y != 1) {
        if (x % y == 0 && oy % y == 0) return y;
        y--;
    }
    return 1;
}

void yakubun(long bunshi,long bunbo,long *newbunshi,long *newbunbo)
{
    BOOL plus;
    long Gcd;

    if (bunshi == 0L) {
	*newbunshi = 0L;
	*newbunbo = 1L;
	return;
    }
    if (bunshi < 0 && bunbo < 0) plus = TRUE;
    else if (bunshi < 0 && bunbo > 0) plus = FALSE;
    else if (bunshi > 0 && bunbo < 0) plus = FALSE;
    else plus = TRUE;
    if (bunshi < 0) bunshi *= -1L;
    if (bunbo < 0) bunbo *= -1L;
    while ((Gcd = gcd(bunshi,bunbo)) != 1) {
	bunshi /= Gcd;
        bunbo /= Gcd;
    }
    if (plus) { *newbunshi = bunshi; *newbunbo = bunbo; return; }
    *newbunshi = bunshi * (-1L);
    *newbunbo = bunbo;
}

void InitCellAndNumber(void)
{
	CELL *p;
	long i;
	AFLOAT *q;
        AINT *q2;
//        char *o;

	p = cl;
	for (i = 0;i < CELL_SIZE;i++) {
		p->gc = 'e';
		p++;
	}
	q = nArea;
	for (i = 0;i < NUMBER_SIZE;i++) {
		q->gc = 'e';
		q++;
	}
	q2 = iArea;
	for (i = 0;i < INT_SIZE;i++) {
		q2->gc = 'e';
		q2++;
	}
//        o = mojiretsuArea;
//        for (i = 0;i < MOJIRETSU_SIZE;i++) *o++ = '\0';
        for (i = 0;i < FILE_POINTER_LEN;i++) FilePointer[i] == NULL;
}

BOOL isAllNull(char *s,long len)
{
    int i;

    for (i = 0;i < len;i++)
        if (*s++ != '\0') return FALSE;
    return TRUE;
}

/*
char *getMojiretsu(char *m)
{
    long len,i;
    char *p;

    len = strlen(m) + 2;
    for (;;) {
        if (curMojiretsu + len >= mojiretsuArea + MOJIRETSU_SIZE) {
	    printf("G[: ̈悪tɂȂ܂BI܂B\n");
	    exit(1);
	    return NULL;
	}
        if (isAllNull(curMojiretsu,len)) {
	    strcpy(curMojiretsu,m);
            p = curMojiretsu;
            curMojiretsu += len - 1;
            *curMojiretsu++ = 'd';
	    return p;
        }
        curMojiretsu++;
    }
}
*/

/*
CELL *getMojiretsuCell(char *m)
{
    char *a;
    CELL *p;

    a = getMojiretsu(m);
    if (a == NULL) return NULL;
    p = getCell();
    if (p == NULL) return NULL;
    p->attr = 'r';
    p->attr2 = 'u';
    p->car = (CELL *)a;
    return p;
}
*/

AFLOAT *getNumber(long double f)
{
	AFLOAT *p;
	long i;

	for (i = 0;i < NUMBER_SIZE - 1;i++) {
	    if (curN->gc == 'e') {
			p = curN++;
            if (curN == nArea + NUMBER_SIZE - 1) curN = nArea;
            p->gc = 'd';
			p->f = f;
			FreeNumberSize--;
			return p;
		}
		curN++;
        if (curN == nArea + NUMBER_SIZE - 1) curN = nArea;
	}
        printf("G[: l̈悪tłBI܂B\n");
	exit(1);
	return NULL; // dummy
}

AINT *getInt(long f)
{
	AINT *p;
	long i;

	for (i = 0;i < INT_SIZE - 1;i++) {
	    if (curI->gc == 'e') {
			p = curI++;
            		if (curI == iArea + INT_SIZE - 1) curI = iArea;
            		p->gc = 'd';
			p->f = f;
			FreeIntSize--;
			return p;
	    }
	    curI++;
            if (curI == iArea + INT_SIZE - 1) curI = iArea;
	}
        printf("G[: ̈悪tłBI܂B\n");
	exit(1);
	return NULL; // dummy
}

char *getString(char *str)
{
	int len;
	char *p;

	len = strlen(str);
	if (curStr + len + 2 - strArea >= STRING_SIZE) {
		printf("G[: XgÖ悪tłBI܂B\n");
		exit(1);
		*curStr = '\0';
		return NULL;
	}
	strcpy(curStr,str);
	p = curStr;
	curStr += len + 1;
	return p;
}

CELL *CheckStringCell(char *u)
{
    CELL **p;

    p = strAreaAddr;
    while (p != curStrAddr) {
        if (!strcmp((char *)((*p)->car),u)) return *p;
        p++;
    }
    return NULL;
}

CELL *getStringCell(char *u)
{
    char *e;
    CELL *p;

    if ((p = CheckStringCell(u)) != NULL) return p;
    e = getString(u); if (e == NULL) return NULL;
    p = getCell(); if (p == NULL) return NULL;
    p->attr = 's';
    if (u[0] == ':') p->attr2 = 'c';
    else p->attr2 = 'u';
    p->car = (CELL *)e;
    if (curStrAddr - strAreaAddr >= STRING_NUM - 1) { printf("G[: XgO̐܂\n"); return NULL; }
    *curStrAddr++ = p;
    return p;
}

BOOL AllocMemory(void)
{
    cl = (CELL *)calloc(CELL_SIZE,sizeof(CELL));
    if (cl == NULL) { printf("G[: Z̈̊lɎs܂B\n"); return FALSE; }
    curCl = cl;
    FreeCellSize = CELL_SIZE;
    strArea = (char *)malloc(STRING_SIZE);
    if (strArea == NULL) { printf("G[: XgÖ̊lɎs܂"); return FALSE; }
    curStr = strArea;
    strAreaAddr = (CELL **)calloc(STRING_NUM,sizeof(CELL *));
    if (strAreaAddr == NULL) { printf("G[: XgOAhẌ̊lɎs܂"); return FALSE; }
    curStrAddr = strAreaAddr;
    nArea = (AFLOAT *)calloc(NUMBER_SIZE,sizeof(AFLOAT));
    if (nArea == NULL) { printf("G[: l̈̊lɎs܂\n"); return FALSE; }
    curN = nArea;
    FreeNumberSize = NUMBER_SIZE;
    iArea = (AINT *)calloc(INT_SIZE,sizeof(AINT));
    if (iArea == NULL) { printf("G[: ̈̊lɎs܂\n"); return FALSE; }
    curI = iArea;
    FreeIntSize = INT_SIZE;
//    mojiretsuArea = (char *)malloc(MOJIRETSU_SIZE);
//    if (mojiretsuArea == NULL) { printf("G[: ̈̊lɎs܂"); return FALSE; }
//    curMojiretsu = mojiretsuArea;
    sv = (SYMVAL *)calloc(GLOBAL_SIZE,sizeof(SYMVAL));
    if (sv == NULL) { printf("G[: O[oϐ̈̊lɎs܂\n"); return FALSE; }
    curSv = sv;
    fv = (SYMVAL *)calloc(FUNCTION_SIZE,sizeof(SYMVAL));
    if (fv == NULL) { printf("G[: ֐̈̊lɎs܂\n"); return FALSE; }
    curFv = fv;
    CellStack = (CELL **)calloc(CELL_STACK_SIZE,sizeof(CELL *));
    if (CellStack == NULL) {
	printf("G[: ZX^bN̈̊lɎs܂\n"); return FALSE;
    }
    LocStack = (SYMVAL **)calloc(LOC_STACK_SIZE,sizeof(SYMVAL *));
    if (LocStack == NULL) {
	printf("G[: [JX^bN̈̊lɎs܂\n"); return FALSE;
    }
    curCellStack = CellStack; curLocStack = LocStack;
    StaticStack = (SYMVAL **)calloc(STATIC_STACK_SIZE,sizeof(SYMVAL *));
    if (StaticStack == NULL) {
	printf("G[: X^eBbNX^bN̈̊lɎs܂\n"); return FALSE;
    }
    curStaticStack = StaticStack;
    InitCellAndNumber();
    return TRUE;
}

char *SkipSpc(char *s)
{
	while (*s == ' ') s++;
	return s;
}

void NewString(char *s2,char *s1)
{
	char *s,*p;

	s = SkipSpc(s1);
	if (s[0] == '(') {
		p = s + 1;
		p = SkipSpc(p);
		strcpy(s2 + 1,p);
		s2[0] = '(';
		return;
	}
	strcpy(s2,s);
}

BOOL isListString(char *str)
{
	if (*str == '(') return TRUE;
	return FALSE;
}

char *SkipDoubleQuote(char *s)
{
    char prev = '"';

    while (*s != '\0') {
        if (*s == '"')
            if (prev != '\\') return s + 1;
        if (isKanji((unsigned char *)s)) { prev = '*'; s++; }
        else prev = *s;
        s++;
    }
    return NULL;
}

char *SkipDoubleQuote2(char *s)
{
    char prev = '"';

    while (*s != '\0') {
        if (*s == '"')
            if (prev != '\\') return s + 1;
        if (isKanji((unsigned char *)s)) {
	    if (*(s + 1) == '\0') return NULL;
	    else { prev = '*'; s++; }
	}
        else prev = *s;
        s++;
    }
    return NULL;
}

void getCarString(char *u,char *str)
{
	int i,ct;

	if (*str == '(') {
		ct = 0;
		for (i = 0;i < (int)strlen(str);i++) {
			if (str[i] == '(') ct++;
			else if (str[i] == ')') ct--;
			if (ct == 0) {
//				mystrncpy(u,str,i + 1);
				strncpy(u,str,i + 1);
				u[i + 1] = '\0';
				return;
			}
			if (*(str + i) == '#' && *(str + i + 1) == '\\' && *(str + i + 2) != '\0') i += 2;
                        else if (*(str + i) == '"') {
			    i += SkipDoubleQuote(str + i + 1) - (str + i) - 1;
			}
			if (isKanji((unsigned char *)(str + i))) i++;
		}
		printf("G[: Eʂ܂\n");
		*u = '\0';
		return;
	}
	else {
		for (i = 0;i < (int)strlen(str);i++) {
			if (str[i] == ' ' || str[i] == '(' || str[i] == ')') {
//				mystrncpy(u,str,i);
				strncpy(u,str,i);
				u[i] = '\0';
				return;
			}
			if (*(str + i) == '#' && *(str + i + 1) == '\\' && *(str + i + 2) != '\0') i += 2;
                        else if (*(str + i) == '"') {
			    i += SkipDoubleQuote(str + i + 1) - (str + i) - 1;
			}
			if (isKanji((unsigned char *)(str + i))) i++;
		}
		strcpy(u,str);
	}
}

void getCdrString(char *s,char *str)
{
	int ct,i;

	if (str[0] == '(') {
		ct = 0;
		for (i = 0;i < (int)strlen(str);i++) {
			if (str[i] == '(') ct++;
			else if (str[i] == ')') ct--;
			if (ct == 0) {
				strcpy(s,str + i + 1);
				return;
			}
			if (*(str + i) == '#' && *(str + i + 1) == '\\' && *(str + i + 2) != '\0') i += 2;
                        else if (*(str + i) == '"') {
			    i += SkipDoubleQuote(str + i + 1) - (str + i) - 1;
			}
			if (isKanji((unsigned char *)(str + i))) i++;
		}
		printf("G[: Eʂ܂\n");
                strcpy(s,"");
		return;
	}
	else {
		for (i = 0;i < (int)strlen(str);i++) {
			if (str[i] == ' ') {
				strcpy(s,str + i + 1);
				return;
			}
			else if (str[i] == '(' || str[i] == ')') {
				strcpy(s,str + i);
				return;
			}
			if (*(str + i) == '#' && *(str + i + 1) == '\\' && *(str + i + 2) != '\0') i += 2;
                        else if (*(str + i) == '"') {
			    i += SkipDoubleQuote(str + i + 1) - (str + i) - 1;
			}
			if (isKanji((unsigned char *)(str + i))) i++;
		}
		strcpy(s,"");
		return;
	}
}

int AnaType(char *u)
{
    char *p;

    if (!strcmp(u,"1+") || !strcmp(u,"1-")) return 0;
    if (u[0] == '.' && isdigit(u[1])) return 1;  // _
    if (u[0] == '-' && u[1] == '.' && isdigit(u[2])) return 1;  // _
    if (isdigit(u[0])) {
        p = u + 1;
        while (*p != '\0') {
            if (*p == '.') {
                if (isdigit(*(p + 1))) return 1;
                else break;
            }
            if (!isdigit(*p)) break;
            p++;
        }
    }
    if (u[0] == '-' && isdigit(u[1])) {
        p = u + 2;
        while (*p != '\0') {
            if (*p == '.') {
                if (isdigit(*(p + 1))) return 1;
                else break;
            }
            if (!isdigit(*p)) break;
            p++;
        }
    }
    if (isdigit(u[0])) {
        p = u + 1;
        while (*p != '\0') {
            if (*p == 'E') {
                if (isdigit(*(p + 1)) || *(p + 1) == '+' || *(p + 1) == '-') return 1;
                else break;
            }
            if (!isdigit(*p)) break;
            p++;
        }
    }
    if (u[0] == '-' && isdigit(u[1])) {
        p = u + 2;
        while (*p != '\0') {
            if (*p == 'E') {
                if (isdigit(*(p + 1)) || *(p + 1) == '+' || *(p + 1) == '-') return 1;
                else break;
            }
            if (!isdigit(*p)) break;
            p++;
        }
    }
    if (isdigit(u[0])) {
        p = u + 1;
        while (*p != '\0') {
            if (*p == '/' && isdigit(*(p + 1))) return 3; // 
            if (!isdigit(*p)) break;
            p++;
        }
        return 2; // 
    }
    if (u[0] == '-' && isdigit(u[1])) {
        p = u + 2;
        while (*p != '\0') {
            if (*p == '/' && isdigit(*(p + 1))) return 3; // 
            if (!isdigit(*p)) break;
            p++;
        }
        return 2; // 
    }
    if (u[0] == '"') return 4; // 
    if (u[0] == '#' && u[1] == '\\' && u[2] != '\0') return 5; // 
    return 0;
}

long double myatof(char *b)
{
    long double v;

    sscanf(b,"%Lg",&v);
    return v;
/*
	TCHAR b1[40];
	char buf[40];
	int i,len;

	mystrncpy(b1,b,40);
	b1[39] = '\0';
	len = lstrlen((LPCWSTR)b1);
	for (i = 0;i < len;i++) buf[i] = (char)b1[i];
	buf[i] = '\0';
	return (float)atof(buf);
*/
}

void getBunshi(char *u,char *re)
{
    while (*u != '/') *re++ = *u++;
    *re = '\0';
}

void getBunbo(char *u,char *re)
{
    while (*u++ != '/');
    strcpy(re,u);
}

CELL *readFromString(char *str)
{
	char *s,*u,*e,*s1,*carS,*cdrS;
	CELL *p;
	long double f;
        long val,vs,vb,nvs,nvb;
	AFLOAT *k;
        AINT *k1,*k2;
	int buflen;
        char bs[20],bb[20];
	char c1,c2;

//printf("str = %s\n",str);
	buflen = strlen(str) + 2;
//	buflen = buflen * 2;
	s = (char *)malloc(buflen);
	u = (char *)malloc(buflen);
	s1 = (char *)malloc(buflen);
	carS = (char *)malloc(buflen);
	cdrS = (char *)malloc(buflen);
	NewString(s,str);
	if (!isListString(s)) {
		getCarString(u,s);
                switch (AnaType(u)) {
                    case 1:
			f = myatof(u);
			p = getCell(); if (p == NULL) goto Error;
			p->attr = 'n';
			k = getNumber(f); if (k == NULL) goto Error;
			p->car = (CELL *)k;
                        break;
                    case 2:
			sscanf(u,"%ld",&val);
integer:
			p = getCell(); if (p == NULL) goto Error;
			p->attr = 'i';
			k2 = getInt(val); if (k2 == NULL) goto Error;
			p->car = (CELL *)k2;
                        break;
		    case 3:
                        getBunshi(u,bs);
			sscanf(bs,"%ld",&vs);
			if (vs == 0) { val = 0; goto integer; }
                        getBunbo(u,bb);
			sscanf(bb,"%ld",&vb);
			if (vb == 0) { printf("G[: 0Ŋ܂B\n"); goto Error; }
			yakubun(vs,vb,&nvs,&nvb);
                        if (nvb == 1) { val = nvs; goto integer; }
			p = getCell(); if (p == NULL) goto Error;
			p->attr = 'b';
			k1 = getInt(nvs); if (k1 == NULL) goto Error;
			k2 = getInt(nvb); if (k2 == NULL) goto Error;
			p->car = (CELL *)k1;
			p->cdr = (CELL *)k2;
			break;
		    case 4:
			p = getMojiretsuCell(u);
			if (p == NULL) goto Error;
			break;
		    case 5:
			c1 = u[2];
			if (isKanji(&c1)) c2 = u[3];
			else c2 = NULL;
			p = getMojiCell(c1,c2);
			if (p == NULL) goto Error;
			break;
                    default:
			p = getStringCell(u); if (p == NULL) goto Error;
                        break;
                }
		free(cdrS);
		free(carS);
		free(s1);
		free(u);
		free(s);
		return p;
	}
	else if (s[0] == '(' && s[1] == ')') {
		free(cdrS);
		free(carS);
		free(s1);
		free(u);
		free(s);
	        return NILCell;
	}
        else if (s[0] == '(' && s[1] == '.' && s[2] == ' ') {  // Add.
            e = s;
            e += 3;
            e = SkipSpc(e);
            p = readFromString(e);
	    free(cdrS);
	    free(carS);
	    free(s1);
	    free(u);
	    free(s);
	    return p;
        }
	else {
		strcpy(s1,s + 1);
		e = SkipSpc(s1);
		getCarString(carS,e);
		getCdrString(cdrS,e);
		p = getCell(); if (p == NULL) goto Error;
		p->attr = 'l';
		p->car = readFromString(carS);
	        if (p->car == NULL) goto Error;
		e = SkipSpc(cdrS);
		strcpy(s1,"(");
		strcat(s1,e);
		p->cdr = readFromString(s1);
        	if (p->cdr == NULL) goto Error;
		free(cdrS);
		free(carS);
		free(s1);
		free(u);
		free(s);

		return p;
	}
  Error:
		free(cdrS);
		free(carS);
		free(s1);
		free(u);
		free(s);
		return NULL;
}

void slide(char *b,int len)
{
	char *q;

	q = b;
	while (*q != '\0') q++;
	while (q != b) {
		*(q + len) = *q;
		q--;
	}
	*(q + len) = *q;
}

char *taiou(char *b)
{
	int ct;

	b = SkipSpc(b);
	while (*b == '\'' || *b == '`' || *b == ',' || *b == '@') b++;
	if (*b != '(') {
		while (*b != '\0' && *b != ')' && *b != ' ' && *b != '(') {
                    if (*b == '"') b = SkipDoubleQuote(b + 1);
                    else if (*b == '#' && *(b + 1) == '\\' && *(b + 2) != '\0') {
                        if (isKanji((unsigned char *)(b + 2))) b = b + 4;
			else b = b + 3;
		    }
                    else {
                        if (isKanji((unsigned char *)b)) b++;
                        b++;
                    }
                }
		return b;
	}
	else {
		ct = 0;
		for (;;) {
			if (*b == '(') ct++;
			else if (*b == ')') {
				ct--;
				if (ct == 0) return b + 1;
			}
                        if (*b == '"') b = SkipDoubleQuote(b + 1);
                        else if (*b == '#' && *(b + 1) == '\\' && *(b + 2) != '\0') {
                            if (isKanji((unsigned char *)(b + 2))) b = b + 4;
			    else b = b + 3;
		        }
                        else {
                            if (isKanji((unsigned char *)b)) b++;
                            b++;
                        }
		}
	}
}

int MakeQuoteText(char *b,int len)
{
	int plen;
	char *q;

	plen = strlen(b);
	if (plen >= len) { printf("G[: r܂\n"); return 0; }
	while (*b != '\0') {
		if (*b == '"') {
		    if ((b = SkipDoubleQuote(b + 1)) == NULL) return 0;
                    else continue;
                }
		else if (*b == '#' && *(b + 1) == '\\') {
		    b = b + 2;
                    if (isKanji(b)) b++;
                    if (*b != '\0') b++;
                    continue;
                }
		if (*b == '\'') {
			*b++ = '('; plen += 6;
                        if (plen >= len) { printf("G[: r܂\n"); return 0; }
			slide(b,6); *b++ = 'Q'; *b++ = 'U'; *b++ = 'O'; *b++ = 'T'; *b++ = 'E'; *b = ' ';
			q = taiou(b);
			plen++; if (plen >= len) { printf("G[: r܂\n"); return 0; }
			slide(q,1);
			*q = ')';
		}
		else {
                    if (isKanji(b)) b++;
                    b++;
                }
	}
	return 1;
}

int MakeFunctionText(char *b,int len)
{
	int plen;
	char *q;

	plen = strlen(b);
	if (plen >= len) { printf("G[: r܂\n"); return 0; }
	while (*b != '\0') {
		if (*b == '"') {
		    if ((b = SkipDoubleQuote(b + 1)) == NULL) return 0;
                    else continue;
                }
		else if (*b == '#' && *(b + 1) == '\\') {
		    b = b + 2;
                    if (isKanji(b)) b++;
                    if (*b != '\0') b++;
                    continue;
                }
		if (*b == '#' && *(b + 1) == '\'') {
			*b++ = '('; plen += 8;
                        if (plen >= len) { printf("G[: r܂\n"); return 0; }
			slide(b,8);
			*b++ = 'F'; *b++ = 'U'; *b++ = 'N'; *b++ = 'C';
			*b++ = 'T'; *b++ = 'I'; *b++ = 'O'; *b++ = 'N'; *b = ' ';
			q = taiou(b);
			plen++; if (plen >= len) { printf("G[: r܂\n"); return 0; }
			slide(q,1);
			*q = ')';
		}
		else {
                    if (isKanji(b)) b++;
                    b++;
                }
	}
	return 1;
}

int MakeBackQuoteText(char *b,int len)
{
	int plen;
	char *q;

	plen = strlen(b);
	if (plen >= len) { printf("G[: r܂\n"); return 0; }
	while (*b != '\0') {
		if (*b == '"') {
		    if ((b = SkipDoubleQuote(b + 1)) == NULL) return 0;
                    else continue;
                }
		else if (*b == '#' && *(b + 1) == '\\') {
		    b = b + 2;
                    if (isKanji(b)) b++;
                    if (*b != '\0') b++;
                    continue;
                }
		if (*b == '`') {
			*b++ = '('; plen += 6 + 4;
                        if (plen >= len) { printf("G[: r܂\n"); return 0; }
			slide(b,6 + 4);
                        *b++ = 'B'; *b++ = 'A'; *b++ = 'C'; *b++ = 'K';
                        *b++ = 'Q'; *b++ = 'U'; *b++ = 'O'; *b++ = 'T'; *b++ = 'E'; *b = ' ';
			q = taiou(b);
			plen++; if (plen >= len) { printf("G[: r܂\n"); return 0; }
			slide(q,1);
			*q = ')';
		}
		else {
                    if (isKanji(b)) b++;
                    b++;
                }
	}
	return 1;
}

int MakeCommaText(char *b,int len)
{
	int plen;
	char *q;

	plen = strlen(b);
	if (plen >= len) { printf("G[: r܂\n"); return 0; }
	while (*b != '\0') {
		if (*b == '"') {
		    if ((b = SkipDoubleQuote(b + 1)) == NULL) return 0;
                    else continue;
                }
		else if (*b == '#' && *(b + 1) == '\\') {
		    b = b + 2;
                    if (isKanji(b)) b++;
                    if (*b != '\0') b++;
                    continue;
                }
		if (*b == ',') {
			*b++ = ','; plen += 1;
                        if (plen >= len) { printf("G[: r܂\n"); return 0; }
			slide(b,1);
                        *b = ' ';
		}
		else {
                    if (isKanji(b)) b++;
                    b++;
                }
	}
	return 1;
}

int MakeAstText(char *b,int len)
{
	int plen;
	char *q;

	plen = strlen(b);
	if (plen >= len) { printf("G[: r܂\n"); return 0; }
	while (*b != '\0') {
		if (*b == '"') {
		    if ((b = SkipDoubleQuote(b + 1)) == NULL) return 0;
                    else continue;
                }
		else if (*b == '#' && *(b + 1) == '\\') {
		    b = b + 2;
                    if (isKanji(b)) b++;
                    if (*b != '\0') b++;
                    continue;
                }
		if (*b == '@') {
			*b++ = '@'; plen += 1;
                        if (plen >= len) { printf("G[: r܂\n"); return 0; }
			slide(b,1);
                        *b = ' ';
		}
		else {
                    if (isKanji(b)) b++;
                    b++;
                }
	}
	return 1;
}

int CrTabOnly(char *s)
{
    while (*s != '\0') {
        if (*s == '\n' || *s == '\r' || *s == '\t' || *s == ' ' || *s == '\'' || *s == '`' || *s == ',' || *s == '@');
        else if (*s == '(' || *s == ')') return 1;
        else if (*s == '"') {
            if (SkipDoubleQuote(s + 1)) return 0;
            else return 1;
        }
        else return 0;
        if (isKanji((unsigned char *)s)) s++;
        s++;
    }
    return 1;
}

int CheckBrace(char *s)
{
    int cnt = 0;
    char *str;

    str = s;
    while (*s != '\0') {
        if (*s == '(') cnt++;
        else if (*s == ')') {
            cnt--;
            if (cnt < 0) return -1;
            else if (cnt == 0) return 1;
        }
        if (*s == '"') {
            if ((s = SkipDoubleQuote(s + 1)) == NULL) return 0;
        }
        else if (*s == '#' && *(s + 1) == '\\' && *(s + 2) != '\0') {
            if (isKanji((unsigned char *)(s + 2))) s = s + 4;
            else s = s + 3;
        }
        else {
            if (isKanji((unsigned char *)s)) s++;
            s++;
        }
    }
    if (CrTabOnly(str)) return 0;
    return 1;
}

int CheckBrace2(char *s)
{
    int cnt = 0;
    char kep = '+';

    while (*s == '\n' || *s == '\r' || *s == '\t' || *s == ' ' || *s == '\'' || *s == '`' || *s == ',' || *s == '@')
	s++;
    if (*s == ')') return -1;
#if 1
    if (*s != '(') {
        while (*s != '\n' && *s != '\r' && *s != '\t' /*&& *s != ' '*/) {
	    if (!isKanji(&kep) && *s == ' ') break;
	    if (*s == '\0') return 0;
            if (!isKanji(&kep)) kep = *s;
	    else kep = '+';
	    s++;
	}
	return 1;
    }
#else
    if (*s != '(') {
        while (*s != '\n' && *s != '\r' && *s != '\t' && *s != ' ') {
	    if (*s == '\0') return 0;
	    s++;
	}
	return 1;
    }
#endif
    while (*s != '\0') {
        if (*s == '(') cnt++;
        else if (*s == ')') {
            cnt--;
            if (cnt < 0) return -1;
            else if (cnt == 0) return 1;
        }
        if (*s == '"') {
            if ((s = SkipDoubleQuote2(s + 1)) == NULL) return 0;
        }
        else if (*s == '#' && *(s + 1) == '\\' && *(s + 2) != '\0') {
            if (isKanji((unsigned char *)(s + 2)) && *(s + 3) != '\0') s = s + 4;
            else s = s + 3;
        }
        else {
            if (isKanji((unsigned char *)s) && *(s + 1) != '\0') s++;
            s++;
        }
    }
    return 0;
}

int GetOneS(void)
{
    char LineBuf[LINE_BUF_SIZE];
    int Size;
    int r;

    Size = 0;
    LineBuf[0] = '\0';
    for (;;) {
        fgets(LineBuf,LINE_BUF_SIZE,stdin);
        Size += strlen(LineBuf);
        if (Size >= BUFLEN) {
            printf("G[: S߂܂B\n");
            return 0;
        }
        strcat(lineStr,LineBuf);
        r = CheckBrace(lineStr);
        if (r == 1) return 1;
        else if (r == -1) {
            printf("G[: )܂B\n");
            return 0;
        }
    }
}

BOOL AllBlank(char *s)
{
    while (*s != '\0') {
        if (!(*s == ' ' || *s == '\t' || *s == '\r' || *s == '\n')) return FALSE;
        s++;
    }
    return TRUE;
}

void SkipComment(FILE *fp)
{
    int c;

    for (;;) {
	c = getc(fp);
	if (c == -1) break;
	if (c == 0x0a) break;
    }
}

int GetOneSStream(FILE *fp)
{
    char LineBuf[LINE_BUF_SIZE];
    int Size;
    int r;
    int c;
    BOOL knj = FALSE;
    char c0;

    Size = 0;
    LineBuf[0] = '\0';
    for (;;) {
//        fgets(LineBuf,LINE_BUF_SIZE,fp);
	if ((c = getc(fp)) == -1) {
	    if (Size == 0) return 0;
	    else if (AllBlank(LineBuf)) return 0;
	    else return 1;
	}
	if (!knj && c == ';') {
	    SkipComment(fp);
	    continue;
	}
	c0 = (char)c;
	if (knj) knj = FALSE;
	else if (!knj && isKanji(&c0)) knj = TRUE;
	sprintf(LineBuf,"%c",(char)c);
        Size += strlen(LineBuf);
        if (Size >= BUFLEN) {
            printf("G[: S߂܂B\n");
            return 0;
        }
        strcat(lineStr,LineBuf);
        r = CheckBrace2(lineStr);
        if (r == 1) return 1;
        else if (r == -1) {
            printf("G[: )܂B\n");
            return 0;
        }
    }
}

void SkipTerm(char *s)
{
    while (*s != '\0') {
        if (*s == '"') {
            s = SkipDoubleQuote(s + 1);
        }
        else if (*s == '#' && *(s + 1) == '\\' && *(s + 2) != '\0') {
	    s += 2;
            if (isKanji(s)) s++;
	    s++;
	}
        else {
            if (*s == '\n') *s = ' ';
	    else if (*s == '\r') *s = ' ';
            else if (*s == '\t') *s = ' ';
            if (isKanji((unsigned char *)s)) s++;
            else *s = toupper(*s);
            s++;
        }
    }
}

void myftoa(char *b,long double v)
{
/*	char buf[30];
	int i,len;*/
        char *p;

	sprintf(b,"%Lg",v);
	p = b;
        while (*p != '\0') {
            if (*p == '.') return;
            else if (*p == 'e') return;
            p++;
        }
        strcat(b,".0");
/*	len = strlen(buf);
	for (i = 0;i < len;i++) b[i] = (TCHAR)buf[i];
	b[i] = '\0';*/
}

void printS(CELL *p)
{
	char buf[30];
	int len;
	BOOL ef;

	if (p->attr == 's') {
		printf("%s",(char *)(p->car));
	}
	else if (p->attr == 'n') {
		myftoa(buf,(((AFLOAT *)(p->car))->f));
		printf("%s",buf);
	}
	else if (p->attr == 'i') {
                printf("%ld",((AINT *)(p->car))->f);
	}
	else if (p->attr == 'b') {
                printf("%ld/%ld",((AINT *)(p->car))->f,((AINT *)(p->cdr))->f);
	}
	else if (p->attr == 'r') {
                printf("%s",(char *)(p->car));
	}
	else if (p->attr == 'm') {
		printf("#\\%c",(char)(p->car));
		if (p->cdr != NULL) printf("%c",(char)(p->cdr));
	}
	else if (p->attr == 'l') {
		printf("(");
		if (p->cdr == NIL) ef = TRUE;
		else ef = FALSE;
		printS2(p,ef);
		printf(")");
	}
	else if (p->attr == 'a' && (p->car)->attr == 'i' &&
		 ((AINT *)((p->car)->car))->f == 1 && (p->cdr)->car == CHARACTER) {
		PutString(p->cdr->cdr,stdout);
	}
	else if (p->attr == 'a') {
		printf("#");
		if ((p->car)->attr == 'i' && ((AINT *)((p->car)->car))->f == 1) ;
		else printS(p->car);
		printf("A");
		printS((p->cdr)->cdr);
		printf(" ");
	}
}

void printS0(CELL *p,BOOL endflag)
{
	char buf[30];
	int len;
	BOOL ef;

	if (p->attr == 's') {
		printf("%s",(char *)(p->car));
		if (!endflag) printf(" ");
	}
	else if (p->attr == 'n') {
		myftoa(buf,(((AFLOAT *)(p->car))->f));
		printf("%s",buf);
		if (!endflag) printf(" ");
	}
	else if (p->attr == 'i') {
                printf("%ld",((AINT *)(p->car))->f);
		if (!endflag) printf(" ");
	}
	else if (p->attr == 'b') {
                printf("%ld/%ld",((AINT *)(p->car))->f,((AINT *)(p->cdr))->f);
		if (!endflag) printf(" ");
	}
	else if (p->attr == 'r') {
                printf("%s",(char *)(p->car));
		if (!endflag) printf(" ");
	}
	else if (p->attr == 'm') {
		printf("#\\%c",(char)(p->car));
		if (p->cdr != NULL) printf("%c",(char)(p->cdr));
		if (!endflag) printf(" ");
	}
	else if (p->attr == 'l') {
		printf("(");
		if (p->cdr == NIL) ef = TRUE;
		else ef = FALSE;
		printS2(p,ef);
		printf(")");
		if (!endflag) printf(" ");
	}
	else if (p->attr == 'a' && (p->car)->attr == 'i' &&
		 ((AINT *)((p->car)->car))->f == 1 && (p->cdr)->car == CHARACTER) {
		PutString(p->cdr->cdr,stdout);
		if (!endflag) printf(" ");	// Added in Apr. 2016
	}
	else if (p->attr == 'a') {
		printf("#");
		if ((p->car)->attr == 'i' && ((AINT *)((p->car)->car))->f == 1) ;
		else printS(p->car);
		printf("A");
		printS((p->cdr)->cdr);
		if (!endflag) printf(" ");
	}
}

void printS2(CELL *p,BOOL endflag)
{
	printS0(p->car,endflag);
	printS3(p->cdr);
}

void printS3(CELL *p)
{
	char b[30];
	int len;
	BOOL ef;

	if (p->attr == 's' && p != NILCell) {
		printf(". ");
		printf("%s",(char *)(p->car));
	}
	else if (p->attr == 'n') {
		myftoa(b,((AFLOAT *)(p->car))->f);
                printf(". %s",b);
	}
	else if (p->attr == 'i') {
                printf(". %ld",((AINT *)(p->car))->f);
	}
	else if (p->attr == 'b') {
                printf(". %ld/%ld",((AINT *)(p->car))->f,((AINT *)(p->cdr))->f);
	}
	else if (p->attr == 'r') {
                printf(". %s",(char *)(p->car));
	}
	else if (p->attr == 'm') {
		printf(". #\\%c",(char)(p->car));
		if (p->cdr != NULL) printf("%c",(char)(p->cdr));
	}
	else if (p->attr == 'l') {
		if (p->cdr == NIL) ef = TRUE;
//		if ((p->car)->attr != 'r' && p->cdr == NIL) ef = TRUE;
		else ef = FALSE;
//ef = FALSE;
		printS2(p,ef);
	}
	else if (p->attr == 'a' && (p->car)->attr == 'i' &&
		 ((AINT *)((p->car)->car))->f == 1 && (p->cdr)->car == CHARACTER) {
		fprintf(stdout,". ");
		PutString(p->cdr->cdr,stdout);
	}
	else if (p->attr == 'a') {
		printf(". ");
		printf("#");
		if ((p->car)->attr == 'i' && ((AINT *)((p->car)->car))->f == 1) ;
		else printS(p->car);
		printf("A");
		printS((p->cdr)->cdr);
		printf(" ");
	}
}

void printSStrm(CELL *p,FILE *fp)
{
	char buf[30];
	int len;
	BOOL ef;

	if (p->attr == 's') {
		fprintf(fp,"%s",(char *)(p->car));
	}
	else if (p->attr == 'n') {
		myftoa(buf,(((AFLOAT *)(p->car))->f));
		fprintf(fp,"%s",buf);
	}
	else if (p->attr == 'i') {
                fprintf(fp,"%ld",((AINT *)(p->car))->f);
	}
	else if (p->attr == 'b') {
                fprintf(fp,"%ld/%ld",((AINT *)(p->car))->f,((AINT *)(p->cdr))->f);
	}
	else if (p->attr == 'r') {
                fprintf(fp,"%s",(char *)(p->car));
	}
	else if (p->attr == 'm') {
		fprintf(fp,"#\\%c",(char)(p->car));
		if (p->cdr != NULL) printf("%c",(char)(p->cdr));
	}
	else if (p->attr == 'l') {
		fprintf(fp,"(");
		if (p->cdr == NIL) ef = TRUE;
		else ef = FALSE;
		printS2Strm(p,ef,fp);
		fprintf(fp,")");
	}
	else if (p->attr == 'a' && (p->car)->attr == 'i' &&
		 ((AINT *)((p->car)->car))->f == 1 && (p->cdr)->car == CHARACTER) {
		PutString(p->cdr->cdr,fp);
	}
	else if (p->attr == 'a') {
		puts("G[: z̓t@Cɏo͂ł܂");
	}
}

void printS0Strm(CELL *p,BOOL endflag,FILE *fp)
{
	char buf[30];
	int len;
	BOOL ef;

	if (p->attr == 's') {
		fprintf(fp,"%s",(char *)(p->car));
		if (!endflag) fprintf(fp," ");
	}
	else if (p->attr == 'n') {
		myftoa(buf,(((AFLOAT *)(p->car))->f));
		fprintf(fp,"%s",buf);
		if (!endflag) fprintf(fp," ");
	}
	else if (p->attr == 'i') {
                fprintf(fp,"%ld",((AINT *)(p->car))->f);
		if (!endflag) fprintf(fp," ");
	}
	else if (p->attr == 'b') {
                fprintf(fp,"%ld/%ld",((AINT *)(p->car))->f,((AINT *)(p->cdr))->f);
		if (!endflag) fprintf(fp," ");
	}
	else if (p->attr == 'r') {
                fprintf(fp,"%s",(char *)(p->car));
		if (!endflag) fprintf(fp," ");
	}
	else if (p->attr == 'm') {
		fprintf(fp,"#\\%c",(char)(p->car));
		if (p->cdr != NULL) fprintf(fp,"%c",(char)(p->cdr));
		if (!endflag) fprintf(fp," ");
	}
	else if (p->attr == 'l') {
		fprintf(fp,"(");
		if (p->cdr == NIL) ef = TRUE;
		else ef = FALSE;
		printS2Strm(p,ef,fp);
		fprintf(fp,")");
		if (!endflag) fprintf(fp," ");
	}
	else if (p->attr == 'a' && (p->car)->attr == 'i' &&
		 ((AINT *)((p->car)->car))->f == 1 && (p->cdr)->car == CHARACTER) {
		PutString(p->cdr->cdr,fp);
		if (!endflag) fprintf(fp," ");
	}
	else if (p->attr == 'a') {
		puts("G[: z̓t@Cɏo͂ł܂");
	}
}

void printS2Strm(CELL *p,BOOL endflag,FILE *fp)
{
	printS0Strm(p->car,endflag,fp);
	printS3Strm(p->cdr,fp);
}

void printS3Strm(CELL *p,FILE *fp)
{
	char b[30];
	int len;
	BOOL ef;

	if (p->attr == 's' && p != NILCell) {
		fprintf(fp,". ");
		fprintf(fp,"%s",(char *)(p->car));
	}
	else if (p->attr == 'n') {
		myftoa(b,((AFLOAT *)(p->car))->f);
                fprintf(fp,". %s",b);
	}
	else if (p->attr == 'i') {
                fprintf(fp,". %ld",((AINT *)(p->car))->f);
	}
	else if (p->attr == 'b') {
                fprintf(fp,". %ld/%ld",((AINT *)(p->car))->f,((AINT *)(p->cdr))->f);
	}
	else if (p->attr == 'r') {
                fprintf(fp,". %s",(char *)(p->car));
	}
	else if (p->attr == 'm') {
		fprintf(fp,". #\\%c",(char)(p->car));
		if (p->cdr != NULL) fprintf(fp,"%c",(char)(p->cdr));
	}
	else if (p->attr == 'l') {
		if (p->cdr == NIL) ef = TRUE;
		else ef = FALSE;
		printS2Strm(p,ef,fp);
	}
	else if (p->attr == 'a' && (p->car)->attr == 'i' &&
		 ((AINT *)((p->car)->car))->f == 1 && (p->cdr)->car == CHARACTER) {
		fprintf(fp,". ");
		PutString(p->cdr->cdr,fp);
	}
	else if (p->attr == 'a') {
		puts("G[: z̓t@Cɏo͂ł܂");
	}
}

void princMojiretsu(char *s,FILE *fp)
{
    int i,len;

    s++;
    len = strlen(s) - 1;
    for (i = 0;i < len;i++) {
	if (isKanji(s)) { fprintf(fp,"%c",*s++); fprintf(fp,"%c",*s++); i++; }
	else if (*s == '\\' && *(s + 1) == '\\') { fprintf(fp,"\\"); s += 2; i++; }
	else if (*s == '\\' && *(s + 1) == '\"') { fprintf(fp,"%c",*(s + 1)); s += 2; i++; }
	else { fprintf(fp,"%c",*s++); }
    }
}

void princS(CELL *p,FILE *fp)
{
	char buf[30];
	int len;
	BOOL ef;

	if (p->attr == 's') {
		fprintf(fp,"%s",(char *)(p->car));
	}
	else if (p->attr == 'n') {
		myftoa(buf,(((AFLOAT *)(p->car))->f));
		fprintf(fp,"%s",buf);
	}
	else if (p->attr == 'i') {
                fprintf(fp,"%ld",((AINT *)(p->car))->f);
	}
	else if (p->attr == 'b') {
                fprintf(fp,"%ld/%ld",((AINT *)(p->car))->f,((AINT *)(p->cdr))->f);
	}
	else if (p->attr == 'r') {
                princMojiretsu((char *)(p->car),fp);
	}
	else if (p->attr == 'm') {
		fprintf(fp,"%c",(char)(p->car));
		if (p->cdr != NULL) fprintf(fp,"%c",(char)(p->cdr));
	}
	else if (p->attr == 'l') {
		fprintf(fp,"(");
		if (p->cdr == NIL) ef = TRUE;
		else ef = FALSE;
		princS2(p,ef,fp);
		fprintf(fp,")");
	}
	else if (p->attr == 'a' && (p->car)->attr == 'i' &&
		 ((AINT *)((p->car)->car))->f == 1 && (p->cdr)->car == CHARACTER) {
		PutStringC(p->cdr->cdr,fp);
	}
	else if (p->attr == 'a') {
		fprintf(fp,"#");
		if ((p->car)->attr == 'i' && ((AINT *)((p->car)->car))->f == 1) ;
		else princS(p->car,fp);
		fprintf(fp,"A");
		princS((p->cdr)->cdr,fp);
		fprintf(fp," ");
	}
}

void princS0(CELL *p,BOOL endflag,FILE *fp)
{
	char buf[30];
	int len;
	BOOL ef;

	if (p->attr == 's') {
		fprintf(fp,"%s",(char *)(p->car));
		if (!endflag) fprintf(fp," ");
	}
	else if (p->attr == 'n') {
		myftoa(buf,(((AFLOAT *)(p->car))->f));
		fprintf(fp,"%s",buf);
		if (!endflag) fprintf(fp," ");
	}
	else if (p->attr == 'i') {
                fprintf(fp,"%ld",((AINT *)(p->car))->f);
		if (!endflag) fprintf(fp," ");
	}
	else if (p->attr == 'b') {
                fprintf(fp,"%ld/%ld",((AINT *)(p->car))->f,((AINT *)(p->cdr))->f);
		if (!endflag) fprintf(fp," ");
	}
	else if (p->attr == 'r') {
                princMojiretsu((char *)(p->car),fp);
		if (!endflag) fprintf(fp," ");
	}
	else if (p->attr == 'm') {
		fprintf(fp,"%c",(char)(p->car));
		if (p->cdr != NULL) fprintf(fp,"%c",(char)(p->cdr));
		if (!endflag) fprintf(fp," ");
	}
	else if (p->attr == 'l') {
		fprintf(fp,"(");
		if (p->cdr == NIL) ef = TRUE;
		else ef = FALSE;
		princS2(p,ef,fp);
		fprintf(fp,")");
		if (!endflag) fprintf(fp," ");
	}
	else if (p->attr == 'a' && (p->car)->attr == 'i' &&
		 ((AINT *)((p->car)->car))->f == 1 && (p->cdr)->car == CHARACTER) {
		PutStringC(p->cdr->cdr,fp);
		if (!endflag) fprintf(fp," ");
	}
	else if (p->attr == 'a') {
		fprintf(fp,"#");
		if ((p->car)->attr == 'i' && ((AINT *)((p->car)->car))->f == 1) ;
		else princS(p->car,fp);
		fprintf(fp,"A");
		princS((p->cdr)->cdr,fp);
		if (!endflag) fprintf(fp," ");
	}
}

void princS2(CELL *p,BOOL endflag,FILE *fp)
{
	princS0(p->car,endflag,fp);
	princS3(p->cdr,fp);
}

void princS3(CELL *p,FILE *fp)
{
	char b[30];
	int len;
	BOOL ef;

	if (p->attr == 's' && p != NILCell) {
		fprintf(fp,". ");
		fprintf(fp,"%s",(char *)(p->car));
	}
	else if (p->attr == 'n') {
		myftoa(b,((AFLOAT *)(p->car))->f);
                fprintf(fp,". %s",b);
	}
	else if (p->attr == 'i') {
                fprintf(fp,". %ld",((AINT *)(p->car))->f);
	}
	else if (p->attr == 'b') {
                fprintf(fp,". %ld/%ld",((AINT *)(p->car))->f,((AINT *)(p->cdr))->f);
	}
	else if (p->attr == 'r') {
                fprintf(fp,". "); princMojiretsu((char *)(p->car),fp);
	}
	else if (p->attr == 'm') {
		fprintf(fp,". %c",(char)(p->car));
		if (p->cdr != NULL) fprintf(fp,"%c",(char)(p->cdr));
	}
	else if (p->attr == 'l') {
		if (p->cdr == NIL) ef = TRUE;
		else ef = FALSE;
		princS2(p,ef,fp);
	}
	else if (p->attr == 'a' && (p->car)->attr == 'i' &&
		 ((AINT *)((p->car)->car))->f == 1 && (p->cdr)->car == CHARACTER) {
		fprintf(fp,". ");
		PutStringC(p->cdr->cdr,fp);
	}
	else if (p->attr == 'a') {
		fprintf(fp,". ");
		fprintf(fp,"#");
		if ((p->car)->attr == 'i' && ((AINT *)((p->car)->car))->f == 1) ;
		else princS(p->car,fp);
		fprintf(fp,"A");
		princS((p->cdr)->cdr,fp);
		fprintf(fp," ");
	}
}

/*
void DumpString(void)
{
    long i = 1;
    char *p;

    p = strArea;
    while (p != curStr) {
        printf("%d. %s\n",i,p);
        while (*p != '\0') p++;
        p++;
        i++;
    }
}
*/

long getSymVal2(CELL *s)
{
	SYMVAL *p;
	long i;
//	TCHAR *u;

	p = sv;
	i = 0;
	while (p != curSv) {
		if (p->sym == s) return i;
		p++;
		i++;
	}
        if (curSv - sv >= GLOBAL_SIZE - 1) {
            printf("G[: O[oϐ̈悪sĂ܂BI܂B\n");
	    exit(1);
	    return -1;
	}
//	if (!(u = getString(s))) return -1;
	curSv->sym = s;
	curSv++;
	return i;
}

long getSymVal(CELL *s)
{
	SYMVAL *p;
	long i;

	p = sv;
	i = 0;
	while (p != curSv) {
		if (p->sym == s) return i;
		p++;
		i++;
	}
	return -1L;
}

CELL *LastCell(CELL *p)
{
    if ((p->cdr)->attr != 'l') return p;
    return LastCell(p->cdr);
}

CELL *Copy(CELL *p)
{
    CELL *r;

    if (p->attr != 'l') return p;
    r = getCell();
    if (r == NULL) return NULL;
    r->attr = 'l';
    r->car = Copy(p->car);
    r->cdr = Copy(p->cdr);
    return r;
}

CELL *backquote2(CELL *p,SYMVAL *loc,long locn)
{
    CELL *r,*q,*e;

    if (p->attr == 'l' && p->car == COMMA && (p->cdr)->attr == 'l' && (p->cdr)->car == AST) {

	IncCellStack(NULL);		// Add in Apr.2016
	IncCellStack(p);		// Add in Apr.2016

	q = eval(((p->cdr)->cdr)->car,loc,locn);

	PopCellStack();			// Add in Apr.2016

	if (q == NULL) return NULL;
        if (q == NILCell) return backquote2(((p->cdr)->cdr)->cdr,loc,locn);
        if (q->attr != 'l') {
            printf("G[: XgłȂ̂͘Ał܂B\n");
            return NULL;
	}
        q = Copy(q);
        if (q == NULL) return NULL;
        e = LastCell(q);

	IncCellStack(NULL);		// Add in Apr.2016
	IncCellStack(q);		// Add in Apr.2016
	IncCellStack(e);		// Add in Apr.2016

        e->cdr = backquote2(((p->cdr)->cdr)->cdr,loc,locn);

	PopCellStack();			// Add in Apr.2016

        return q;
    }
    else if (p->attr == 'l' && p->car == COMMA) {
        if ((p->cdr)->attr != 'l') { printf("G[: ,̌ɒl܂B\n"); return NULL; }
        r = getCell();
        if (r == NULL) return NULL;
        r->attr = 'l';

	IncCellStack(NULL);		// Add in Apr.2016
	IncCellStack(p);		// Add in Apr.2016
	IncCellStack(r);		// Add in Apr.2016

        r->car = eval((p->cdr)->car,loc,locn);
        if (r->car == NULL) { PopCellStack(); return NULL; }
        r->cdr = backquote2((p->cdr)->cdr,loc,locn);

	PopCellStack();			// Add in Apr.2016

        return r;
    }
    else if (p->attr == 'l') {
        r = getCell();
        if (r == NULL) return NULL;
        r->attr = 'l';

	IncCellStack(NULL);		// Add in Apr.2016
	IncCellStack(p);		// Add in Apr.2016
	IncCellStack(r);		// Add in Apr.2016

        r->car = backquote2(p->car,loc,locn);
        if (r->car == NULL) { PopCellStack(); return NULL; }
        r->cdr = backquote2(p->cdr,loc,locn);

	PopCellStack();			// Add in Apr.2016

        if (r->cdr == NULL) return NULL;
        return r;
    }
    else {
        return p;
    }
}

CELL *backquote(CELL *p,SYMVAL *loc,long locn)
{
    CELL *q,*r;
    char flag;

    if (p->attr == 'l' && p->car == COMMA && (p->cdr)->attr == 'l' && (p->cdr)->car == AST) {
        printf("G[: @Ⴂ܂B\n");
        return NULL;
    }
    if (p->attr == 'l' && p->car == COMMA && (p->cdr)->attr == 'l' && ((p->cdr)->cdr)->attr == 's') {
        q = eval((p->cdr)->car,loc,locn);
        return q;
    }
    else if (p->attr == 'l') {
        return backquote2(p->car,loc,locn);
    }
    else {
        printf("G[: @Ⴂ܂B\n");
        return NULL;
    }
}

SYMVAL *getFuncval(CELL *s)
{
	SYMVAL *p;

	p = fv;
	while (p != curFv) {
		if (p->sym == s) return p;
		p++;
	}
	if (curFv - fv >= FUNCTION_SIZE - 1) {
		printf("G[: ֐̈悪tɂȂ܂BI܂B\n");
		exit(1);
		return NULL;
	}
	curFv++;
	return p;
}

SYMVAL *getFuncval2(CELL *s)
{
	SYMVAL *p;

	p = fv;
	while (p != curFv) {
		if (p->sym == s) return p;
		p++;
	}
	return NULL;
}

long tlength(CELL *p)
{
	long i;

	i = 0;
	for (;;) {
		if (p->attr != 'l') return i;
		i++;
		p = p->cdr;
	}
}

CELL *MakeRest(CELL *v,SYMVAL *loc,long locn)
{
    CELL *p;

    if (v->attr != 'l') return v;
    if ((p = getCell()) == NULL) return NULL;;
    p->attr = 'l';

    IncCellStack(NULL);		// Add in Apr.2016
    IncCellStack(p);		// Add in Apr.2016
    IncCellStack(v);		// Add in Apr.2016

    p->car = eval(v->car,loc,locn);
    if (p->car == NULL) { PopCellStack(); return NULL; }
    p->cdr = MakeRest(v->cdr,loc,locn);

    PopCellStack();		// Add in Apr.2016

    if (p->cdr == NULL) return NULL;
    return p;
}

BOOL initTemploc(SYMVAL *l,// temploc
                 long len, // ̒
                 CELL *s,  // 
                 CELL *v,  // 
                 SYMVAL *loc,
                 long locn )
{
	CELL *p;
	long i;
        long k = -1;

	if (l == NULL || len == 0) return TRUE; // Add on 2014.2.25
//	if (len != tlength(v)) return FALSE;
	p = s;
	for (i = 0;i < len;i++) {
                if (p->car == AMPREST) {
                    k = i;
                    if (!(i + 1 < len)) return FALSE;
                    p = p->cdr;
                }
		if ((p->car)->attr != 's') return FALSE;
		l[i].sym = p->car;
		l[i].val = NILCell;
		p = p->cdr;
                if (k != -1) {
                    break;
                }
	}
	if (k != -1) l[len - 1].sym = NULL;    // Add.
        if (p->attr != 's') return FALSE;
//printf("here\n");
        if (k != -1) len--;

	IncCellStack(NULL);
	IncCellStack(v);

	for (i = 0;i < len;i++) {
		if (i != k && v->attr != 'l') { PopCellStack(); return FALSE; }

		//IncCellStack(NULL);		// Add in Apr.2016
		//IncCellStack(v);		// Add in Apr.2016

                if (i == k) {
                    l[i].val = MakeRest(v,loc,locn);
                    if (l[i].val == NULL) { PopCellStack(); return FALSE; }
                }
		else if ((l[i].val = eval(v->car,loc,locn)) == NULL) { PopCellStack(); return FALSE; }
//static long kazu = 0; if (kazu++ > 50000000) { printS(v->car); printf("\n"); }
		//PopCellStack();			// Add in Apr.2016
		IncCellStack(l[i].val);
//printS(v);
		v = v->cdr;
//printS(v);
	}
	PopCellStack();

        if (k == -1 && v->attr != 's') { return FALSE; }
//for (i = 0; i < len;i++) printf("%x ",l[i].sym);
	return TRUE;
}

CELL *tprogn(CELL *s,SYMVAL *loc,long locn)
{
	CELL *p;

	p = NILCell;

	IncCellStack(NULL);		// Add in Apr.2016
	IncCellStack(s);		// Add in Apr.2016

	for (;;) {
		if (s->attr != 'l') { PopCellStack(); return p; }
		if ((p = eval(s->car,loc,locn)) == NULL) { PopCellStack(); return NULL; }
		s = s->cdr;
	}
}

CELL *tprog1(CELL *s,SYMVAL *loc,long locn)
{
	CELL *p,*ret;
	BOOL First = TRUE;

	ret = NILCell;

	IncCellStack(NULL);		// Add in Apr.2016
	IncCellStack(s);		// Add in Apr.2016
	IncCellStack(ret);		// Add in Apr.2016

	for (;;) {
		if (s->attr != 'l') { PopCellStack(); return ret; }
		if ((p = eval(s->car,loc,locn)) == NULL) { PopCellStack(); return NULL; }
		if (First) {
		    ret = p;
		    IncCellStack(ret);
		    First = FALSE;
		}
		s = s->cdr;
	}
}

long getLocal(SYMVAL *loc,long locn,CELL *s)
{
	long i;

	for (i = 0;i < locn;i++) {
		if ((loc + i)->sym != NULL && s == (loc + i)->sym) return i;
        }
	return -1;
}

void DumpSymval(SYMVAL *loc,long locn)
{
    long i;

    for (i = 0;i < locn;i++) {
//	printf("attr = %c\n",loc[i].attr);
        printS(loc[i].sym); printf(" ");
        printS(loc[i].val); printf("\n");
    }
}

CELL *Let(CELL *p,SYMVAL *loc,long locn)
{
    long len,i,j,newlen;
    SYMVAL *temploc;
    CELL *q,*r;

    if (p->attr != 'l') goto letserror;
    len = tlength(p->car);
    newlen = len + locn;
    if (len != 0) temploc = (SYMVAL *)calloc(newlen,sizeof(SYMVAL));
    else return tprogn(p->cdr,loc,locn);
    if (temploc == NULL) { printf("G[: Ǐϐ̊mۂɎs܂B\n"); return NULL; }
    j = 0;
    for (i = len;i < newlen;i++) {
        temploc[i].attr = loc[j].attr;
        temploc[i].sym = loc[j].sym;
        temploc[i].val = loc[j++].val;
    }
    q = p->car;

    IncCellStack(NULL);
    IncCellStack(q);

    for (i = 0;i < len;i++) {
        r = q->car;
        if (r->attr != 'l') { PopCellStack(); goto letserror2; }
        if ((r->car)->attr != 's') { PopCellStack(); goto letserror2; }
        temploc[i].sym = r->car;
        if ((r->cdr)->attr != 'l') temploc[i].val = NILCell;
        else {
            temploc[i].val = eval((r->cdr)->car,loc,locn);
            if (temploc[i].val == NULL) { free(temploc); PopCellStack(); return NULL; }
        }
        q = q->cdr;
    }

    PopCellStack();

    IncLocStack(temploc,newlen);
//DumpSymval(temploc,newlen);
    q = tprogn(p->cdr,temploc,newlen);
    PopLocStack();
    SetOrgLoc(loc,locn,temploc,len,newlen);
/* Deleted in Apr.2016
    if (q != NULL) IncCellStack(q);
*/
    if (q != NULL && q->cljlen != 0) {
	IncStaticStack(temploc,newlen);
	return q;  // Added on 2014.3.1
    }

    free(temploc);
    return q;

letserror2:
    free(temploc);
letserror:
    printf("G[: @Ⴂ܂B\n");
    return NULL;
}

BOOL initTemplocForMacro(SYMVAL *l,// temploc
                 long len, // ̒
                 CELL *s,  // 
                 CELL *v ) // 
{
	CELL *p;
	long i;
        long k = -1;

	p = s;
	for (i = 0;i < len;i++) {
                if (p->car == AMPREST) {
                    k = i;
                    if (!(i + 1 < len)) return FALSE;
                    p = p->cdr;
                }
                else if (p->car == AMPBODY) {
                    k = i;
                    if (!(i + 1 < len)) return FALSE;
                    p = p->cdr;
                }
		if ((p->car)->attr != 's') return FALSE;
		l[i].sym = p->car;
		p = p->cdr;
                if (k != -1) {
                    break;
                }
	}
        if (p->attr != 's') return FALSE;
        if (k != -1) len--;
	for (i = 0;i < len;i++) {
		if (i != k && v->attr != 'l') return FALSE;
                if (i == k) {
                    l[i].val = v;
//                    if (l[i].val == NULL) return FALSE;
                }
		else {
		    l[i].val = v->car;
                }
		v = v->cdr;
	}
        if (k == -1 && v->attr != 's') return FALSE;
        if (k != -1) l[i].sym = NULL;
	return TRUE;
}

CELL *MacroExec(CELL *p,SYMVAL *m,SYMVAL *loc,long locn)
{
    long len,i,j,newlen;
    SYMVAL *temploc;
    CELL *q;

    len = tlength((m->val)->car);
    newlen = len + locn;
    if (newlen != 0) {
	temploc = (SYMVAL *)calloc(newlen,sizeof(SYMVAL));
	if (temploc == NULL) {
	    printf("G[: [Jϐ̈̊mۂɎs܂\n");
	    return NULL;
	}
    }
    else temploc = NULL;
    if (!initTemplocForMacro(temploc,len,(m->val)->car,p)) {
	printf("G[: ̐Ⴂ܂\n");
	free(temploc);
	return NULL;
    }
    j = 0;
    for (i = len;i < newlen;i++) {
        temploc[i].attr = loc[j].attr;
        temploc[i].sym = loc[j].sym;
        temploc[i].val = loc[j++].val;
    }
    if (((m->val)->cdr)->attr != 'l') {
        free(temploc);
        return NILCell;
    }
    IncLocStack(temploc,newlen);
    if ((q = eval(((m->val)->cdr)->car,temploc,newlen)) == NULL) return NULL;
    PopLocStack();
    free(temploc);
    return eval(q,loc,locn);
}

CELL *MacroExec2(CELL *p,SYMVAL *m,SYMVAL *loc,long locn)
{
    long len,i,j,newlen;
    SYMVAL *temploc;
    CELL *q;

    len = tlength((m->val)->car);
    newlen = len + locn;
    if (newlen != 0) {
	temploc = (SYMVAL *)calloc(newlen,sizeof(SYMVAL));
	if (temploc == NULL) {
	    printf("G[: [Jϐ̈̊mۂɎs܂\n");
	    return NULL;
	}
    }
    else temploc = NULL;
    if (!initTemplocForMacro(temploc,len,(m->val)->car,p)) {
	printf("G[: ̐Ⴂ܂\n");
	free(temploc);
	return NULL;
    }
    j = 0;
    for (i = len;i < newlen;i++) {
        temploc[i].attr = loc[j].attr;
        temploc[i].sym = loc[j].sym;
        temploc[i].val = loc[j++].val;
    }
    if (((m->val)->cdr)->attr != 'l') {
        free(temploc);
        return NILCell;
    }
    IncLocStack(temploc,newlen);
    if ((q = eval(((m->val)->cdr)->car,temploc,newlen)) == NULL) return NULL;
    PopLocStack();
    free(temploc);
    return q;
}

CELL *LetAst(CELL *p,SYMVAL *loc,long locn)
{
    CELL *q,*r;
    long len,i,j;
    SYMVAL *temploc;

    if (p->attr != 'l') goto letastserror;
    q = p->car;
    if (q->attr != 'l') goto letastserror;
    len = tlength(q);
    if (len == 0) return tprogn(p->cdr,loc,locn);
    temploc = (SYMVAL *)calloc(len + locn,sizeof(SYMVAL));
    if (temploc == NULL) { printf("G[: Ǐϐ̊mۂɎs܂B\n"); return NULL; }
    j = 0;
    for (i = len;i < len + locn;i++) {
        temploc[i].attr = loc[j].attr;
        temploc[i].sym = loc[j].sym;
	temploc[i].val = loc[j++].val;
    }
    for (i = 0;i < len;i++)
        temploc[i].sym = NULL;
    for (i = 0;i < len;i++) {
        r = q->car;
        if (r->attr != 'l') goto letastserror2;
        if ((r->car)->attr != 's') goto letastserror2;
        temploc[i].sym = r->car;
        if ((r->cdr)->attr != 'l') temploc[i].val = NILCell;
        else {
//	    IncLocStack(temploc,len + locn);
//printS((r->cdr)->car); printf("\n");
            temploc[i].val = eval((r->cdr)->car,temploc,len + locn);
//	    PopLocStack();
            if (temploc[i].val == NULL) { free(temploc); return NULL; }
        }
        q = q->cdr;
    }
    IncLocStack(temploc,len + locn);
//DumpSymval(temploc,len + locn);
    q = tprogn(p->cdr,temploc,len + locn);
/* Deleted in Apr.2016
    if (q != NULL) IncCellStack(q);
*/
    PopLocStack();
    SetOrgLoc(loc,locn,temploc,len,len + locn);

    if (q != NULL && q->cljlen != 0) {
	IncStaticStack(temploc,len + locn);
	return q;  // Added on 2014.3.1
    }

    free(temploc);
    return q;

letastserror2:
    free(temploc);
letastserror:
    printf("G[: @Ⴂ܂B\n");
    return NULL;
}

int progBody2(CELL *p,SYMVAL *loc,long locn)
{
    CELL *q,*r;

    r = NILCell;
    for (;;) {
        if (p->attr != 'l') break;
        q = p->car;
        if (q->attr == 's') {
            p = p->cdr;
            continue;
        }
        ReturnFlag = 'u';
//printS(q);

	IncCellStack(NULL);	// Added in Apr.2016
	IncCellStack(p);	// Added in Apr.2016

        if (eval(q,loc,locn) == NULL) return 2;

	PopCellStack();		// Added in Apr.2016

        if (ReturnFlag != 'u') {
            ReturnFlag = 'u';
            return 3;
        }
        if (GoSymbol != NULL) return 0;
        p = p->cdr;
    }
    ReturnValue = r;
    return 1;
}

CELL *tmember(CELL *key,CELL *ob)
{
    while (ob->attr == 'l') {
        if (key == ob->car) return ob;
        ob = ob->cdr;
    }
    return NILCell;
}

CELL *progBody(CELL *p,SYMVAL *loc,long locn)
{
    CELL *q,*r;
    int ret;

    GoSymbol = NULL;
    for (;;) {
        if (GoSymbol == NULL) q = p;
        else {
            q = tmember(GoSymbol,p);
            if (q == NILCell) {
		printf("G[: x܂B\n");
                return NULL;
            }
            GoSymbol = NULL;
        }

	IncCellStack(NULL);	// Added in Apr.2016
	IncCellStack(p);	// Added in Apr.2016

        ret = progBody2(q,loc,locn);

	PopCellStack();		// Added in Apr.2016

        if (ret == 1 || ret == 3) break;
        else if (ret == 2) return NULL;
    }
    return ReturnValue;
}

CELL *prog(CELL *p,SYMVAL *loc,long locn)
{
    CELL *q;
    long len,i,j;
    SYMVAL *temploc;

    if (p->attr != 'l') goto progserror;
    q = p->car;
    len = tlength(q);
    if (len == 0) return progBody(p->cdr,loc,locn);
    temploc = (SYMVAL *)calloc(len + locn,sizeof(SYMVAL));
    if (temploc == NULL) { printf("G[: Ǐϐ̊mۂɎs܂B\n"); return NULL; }
    j = 0;
    for (i = len;i < len + locn;i++)
        temploc[i] = loc[j++];
    for (i = 0;i < len;i++) {
        if ((q->car)->attr != 's') goto progserror2;
        temploc[i].sym = q->car;
        temploc[i].val = NILCell;
        q = q->cdr;
    }
    IncLocStack(temploc,len + locn);
    q = progBody(p->cdr,temploc,len + locn);
    SetOrgLoc(loc,locn,temploc,len,len + locn);
    PopLocStack();
    free(temploc);
    return q;

progserror2:
    free(temploc);
progserror:
    printf("G[: @Ⴂ܂B\n");
    return NULL;
}

CELL *tand(CELL *p,SYMVAL *loc,long locn)
{
	CELL *q;

	for (;;) {
		if (p->attr != 'l') { q->mtop = NULL; return q; }

		IncCellStack(NULL);	// Added in Apr.2016
		IncCellStack(p);	// Added in Apr.2016

		if ((q = eval(p->car,loc,locn)) == NULL) return NULL;

		PopCellStack();		// Added in Apr.2016

		if (q == NILCell) return NILCell;
		p = p->cdr;
	}
}

CELL *tor(CELL *p,SYMVAL *loc,long locn)
{
	CELL *q;

	for (;;) {
		if (p->attr != 'l') return NILCell;

		IncCellStack(NULL);
		IncCellStack(p);

		if ((q = eval(p->car,loc,locn)) == NULL) { PopCellStack(); return NULL; }

		PopCellStack();

		if (q != NILCell) { q->mtop = NULL; return q; }
//		else if (q->attr == 'n') return TCell;
		p = p->cdr;
	}
}

void WaWithTsubun(long a,long b,long c,long d,long *e,long *f)
{
    long bunshi,bunbo;

    bunbo = b * d;
    bunshi = a * d + b * c;
    yakubun(bunshi,bunbo,e,f);
}

CELL *Wa(CELL *x,CELL *y)
{
    AINT *a,*a2;
    CELL *p;
    AFLOAT *b;
    long bunshi,bunbo;

    if (x->attr == 'i' && y->attr == 'i') {
	a = getInt(((AINT *)(x->car))->f + ((AINT *)(y->car))->f);
	if (a == NULL) return NULL;
	p = getCell();
	if (p == NULL) return NULL;
	p->attr = 'i';
	p->car = (CELL *)a;
	return p;
    }
    if (x->attr == 'n' && y->attr == 'n') {
	b = getNumber(((AFLOAT *)(x->car))->f + ((AFLOAT *)(y->car))->f);
	if (b == NULL) return NULL;
	p = getCell();
	if (p == NULL) return NULL;
	p->attr = 'n';
	p->car = (CELL *)b;
	return p;
    }
    if (x->attr == 'i' && y->attr == 'n') {
	b = getNumber((long double)(((AINT *)(x->car))->f) + ((AFLOAT *)(y->car))->f);
	if (b == NULL) return NULL;
	p = getCell();
	if (p == NULL) return NULL;
	p->attr = 'n';
	p->car = (CELL *)b;
	return p;
    }
    if (x->attr == 'n' && y->attr == 'i') {
	b = getNumber(((AFLOAT *)(x->car))->f + (long double)(((AINT *)(y->car))->f));
	if (b == NULL) return NULL;
	p = getCell();
	if (p == NULL) return NULL;
	p->attr = 'n';
	p->car = (CELL *)b;
	return p;
    }
    if (x->attr == 'b' && y->attr == 'b') {
	WaWithTsubun(((AINT *)(x->car))->f,((AINT *)(x->cdr))->f,((AINT *)(y->car))->f,((AINT *)(y->cdr))->f,
		     &bunshi,&bunbo );
	if (bunbo == 1L) {
	    a = getInt(bunshi);
	    if (a == NULL) return NULL;
	    p = getCell();
	    if (p == NULL) return NULL;
	    p->attr = 'i';
	    p->car = (CELL *)a;
	    return p;
	}
	a = getInt(bunshi);
	if (a == NULL) return NULL;
	a2 = getInt(bunbo);
	if (a2 == NULL) return NULL;
	p = getCell();
	if (p == NULL) return NULL;
	p->attr = 'b';
	p->car = (CELL *)a;
	p->cdr = (CELL *)a2;
	return p;
    }
    if (x->attr == 'b' && y->attr == 'n') {
	b = getNumber((long double)(((AINT *)(x->car))->f) / (long double)(((AINT *)(x->cdr))->f) +
		      ((AFLOAT *)(y->car))->f );
	if (b == NULL) return NULL;
	p = getCell();
	if (p == NULL) return NULL;
	p->attr = 'n';
	p->car = (CELL *)b;
	return p;
    }
    if (x->attr == 'n' && y->attr == 'b') {
	b = getNumber((long double)(((AINT *)(y->car))->f) / (long double)(((AINT *)(y->cdr))->f) +
		      ((AFLOAT *)(x->car))->f );
	if (b == NULL) return NULL;
	p = getCell();
	if (p == NULL) return NULL;
	p->attr = 'n';
	p->car = (CELL *)b;
	return p;
    }
    if (x->attr == 'b' && y->attr == 'i') {
	WaWithTsubun(((AINT *)(x->car))->f,((AINT *)(x->cdr))->f,((AINT *)(y->car))->f,1L,&bunshi,&bunbo);
	if (bunbo == 1L) {
	    a = getInt(bunshi);
	    if (a == NULL) return NULL;
	    p = getCell();
	    if (p == NULL) return NULL;
	    p->attr = 'i';
	    p->car = (CELL *)a;
	    return p;
	}
	a = getInt(bunshi);
	if (a == NULL) return NULL;
	a2 = getInt(bunbo);
	if (a2 == NULL) return NULL;
	p = getCell();
	if (p == NULL) return NULL;
	p->attr = 'b';
	p->car = (CELL *)a;
	p->cdr = (CELL *)a2;
	return p;
    }
    if (x->attr == 'i' && y->attr == 'b') {
	WaWithTsubun(((AINT *)(y->car))->f,((AINT *)(y->cdr))->f,((AINT *)(x->car))->f,1L,&bunshi,&bunbo);
	if (bunbo == 1L) {
	    a = getInt(bunshi);
	    if (a == NULL) return NULL;
	    p = getCell();
	    if (p == NULL) return NULL;
	    p->attr = 'i';
	    p->car = (CELL *)a;
	    return p;
	}
	a = getInt(bunshi);
	if (a == NULL) return NULL;
	a2 = getInt(bunbo);
	if (a2 == NULL) return NULL;
	p = getCell();
	if (p == NULL) return NULL;
	p->attr = 'b';
	p->car = (CELL *)a;
	p->cdr = (CELL *)a2;
	return p;
    }
    printf("G[: ͐lł͂܂B\n");
    return NULL;
}

CELL *Sa(CELL *x,CELL *y)
{
    AINT *a,*a2;
    CELL *p;
    AFLOAT *b;
    long bunshi,bunbo;

    if (x->attr == 'i' && y->attr == 'i') {
	a = getInt(((AINT *)(x->car))->f - ((AINT *)(y->car))->f);
	if (a == NULL) return NULL;
	p = getCell();
	if (p == NULL) return NULL;
	p->attr = 'i';
	p->car = (CELL *)a;
	return p;
    }
    if (x->attr == 'n' && y->attr == 'n') {
	b = getNumber(((AFLOAT *)(x->car))->f - ((AFLOAT *)(y->car))->f);
	if (b == NULL) return NULL;
	p = getCell();
	if (p == NULL) return NULL;
	p->attr = 'n';
	p->car = (CELL *)b;
	return p;
    }
    if (x->attr == 'i' && y->attr == 'n') {
	b = getNumber((long double)(((AINT *)(x->car))->f) - ((AFLOAT *)(y->car))->f);
	if (b == NULL) return NULL;
	p = getCell();
	if (p == NULL) return NULL;
	p->attr = 'n';
	p->car = (CELL *)b;
	return p;
    }
    if (x->attr == 'n' && y->attr == 'i') {
	b = getNumber(((AFLOAT *)(x->car))->f - (long double)(((AINT *)(y->car))->f));
	if (b == NULL) return NULL;
	p = getCell();
	if (p == NULL) return NULL;
	p->attr = 'n';
	p->car = (CELL *)b;
	return p;
    }
    if (x->attr == 'b' && y->attr == 'b') {
	WaWithTsubun(((AINT *)(x->car))->f,((AINT *)(x->cdr))->f,((AINT *)(y->car))->f * (-1L),((AINT *)(y->cdr))->f,
		     &bunshi,&bunbo );
	if (bunbo == 1L) {
	    a = getInt(bunshi);
	    if (a == NULL) return NULL;
	    p = getCell();
	    if (p == NULL) return NULL;
	    p->attr = 'i';
	    p->car = (CELL *)a;
	    return p;
	}
	a = getInt(bunshi);
	if (a == NULL) return NULL;
	a2 = getInt(bunbo);
	if (a2 == NULL) return NULL;
	p = getCell();
	if (p == NULL) return NULL;
	p->attr = 'b';
	p->car = (CELL *)a;
	p->cdr = (CELL *)a2;
	return p;
    }
    if (x->attr == 'b' && y->attr == 'n') {
	b = getNumber((long double)(((AINT *)(x->car))->f) / (long double)(((AINT *)(x->cdr))->f) +
		      ((AFLOAT *)(y->car))->f * (-1L) );
	if (b == NULL) return NULL;
	p = getCell();
	if (p == NULL) return NULL;
	p->attr = 'n';
	p->car = (CELL *)b;
	return p;
    }
    if (x->attr == 'n' && y->attr == 'b') {
	b = getNumber((long double)(((AINT *)(y->car))->f * (-1L)) / (long double)(((AINT *)(y->cdr))->f) +
		      ((AFLOAT *)(x->car))->f );
	if (b == NULL) return NULL;
	p = getCell();
	if (p == NULL) return NULL;
	p->attr = 'n';
	p->car = (CELL *)b;
	return p;
    }
    if (x->attr == 'b' && y->attr == 'i') {
	WaWithTsubun(((AINT *)(x->car))->f,((AINT *)(x->cdr))->f,((AINT *)(y->car))->f * (-1L),1L,&bunshi,&bunbo);
	if (bunbo == 1L) {
	    a = getInt(bunshi);
	    if (a == NULL) return NULL;
	    p = getCell();
	    if (p == NULL) return NULL;
	    p->attr = 'i';
	    p->car = (CELL *)a;
	    return p;
	}
	a = getInt(bunshi);
	if (a == NULL) return NULL;
	a2 = getInt(bunbo);
	if (a2 == NULL) return NULL;
	p = getCell();
	if (p == NULL) return NULL;
	p->attr = 'b';
	p->car = (CELL *)a;
	p->cdr = (CELL *)a2;
	return p;
    }
    if (x->attr == 'i' && y->attr == 'b') {
	WaWithTsubun(((AINT *)(y->car))->f * (-1L),((AINT *)(y->cdr))->f,((AINT *)(x->car))->f,1L,&bunshi,&bunbo);
	if (bunbo == 1L) {
	    a = getInt(bunshi);
	    if (a == NULL) return NULL;
	    p = getCell();
	    if (p == NULL) return NULL;
	    p->attr = 'i';
	    p->car = (CELL *)a;
	    return p;
	}
	a = getInt(bunshi);
	if (a == NULL) return NULL;
	a2 = getInt(bunbo);
	if (a2 == NULL) return NULL;
	p = getCell();
	if (p == NULL) return NULL;
	p->attr = 'b';
	p->car = (CELL *)a;
	p->cdr = (CELL *)a2;
	return p;
    }
    printf("G[: ͐lł͂܂B\n");
    return NULL;
}

CELL *Seki(CELL *x,CELL *y)
{
    AINT *a,*a2;
    CELL *p;
    AFLOAT *b;
    long bunshi,bunbo,oldbunshi,oldbunbo;

    if (x->attr == 'i' && y->attr == 'i') {
	a = getInt(((AINT *)(x->car))->f * ((AINT *)(y->car))->f);
	if (a == NULL) return NULL;
	p = getCell();
	if (p == NULL) return NULL;
	p->attr = 'i';
	p->car = (CELL *)a;
	return p;
    }
    if (x->attr == 'n' && y->attr == 'n') {
	b = getNumber(((AFLOAT *)(x->car))->f * ((AFLOAT *)(y->car))->f);
	if (b == NULL) return NULL;
	p = getCell();
	if (p == NULL) return NULL;
	p->attr = 'n';
	p->car = (CELL *)b;
	return p;
    }
    if (x->attr == 'i' && y->attr == 'n') {
	if (((AINT *)(x->car))->f == 0L) {
	    a = getInt(0L);
	    p = getCell();
	    p->attr = 'i';
	    p->car = (CELL *)a;
	    return p;
	}
	b = getNumber((long double)(((AINT *)(x->car))->f) * ((AFLOAT *)(y->car))->f);
	if (b == NULL) return NULL;
	p = getCell();
	if (p == NULL) return NULL;
	p->attr = 'n';
	p->car = (CELL *)b;
	return p;
    }
    if (x->attr == 'n' && y->attr == 'i') {
	if (((AINT *)(y->car))->f == 0L) {
	    a = getInt(0L);
	    p = getCell();
	    p->attr = 'i';
	    p->car = (CELL *)a;
	    return p;
	}
	b = getNumber(((AFLOAT *)(x->car))->f * (long double)(((AINT *)(y->car))->f));
	if (b == NULL) return NULL;
	p = getCell();
	if (p == NULL) return NULL;
	p->attr = 'n';
	p->car = (CELL *)b;
	return p;
    }
    if (x->attr == 'b' && y->attr == 'b') {
        oldbunshi = ((AINT *)(x->car))->f * ((AINT *)(y->car))->f;
        oldbunbo = ((AINT *)(x->cdr))->f * ((AINT *)(y->cdr))->f;
        yakubun(oldbunshi,oldbunbo,&bunshi,&bunbo);
	if (bunbo == 1L) {
	    a = getInt(bunshi);
	    if (a == NULL) return NULL;
	    p = getCell();
	    if (p == NULL) return NULL;
	    p->attr = 'i';
	    p->car = (CELL *)a;
	    return p;
	}
	a = getInt(bunshi);
	if (a == NULL) return NULL;
	a2 = getInt(bunbo);
	if (a2 == NULL) return NULL;
	p = getCell();
	if (p == NULL) return NULL;
	p->attr = 'b';
	p->car = (CELL *)a;
	p->cdr = (CELL *)a2;
	return p;
    }
    if (x->attr == 'b' && y->attr == 'n') {
	b = getNumber((long double)(((AINT *)(x->car))->f) / (long double)(((AINT *)(x->cdr))->f) *
		      ((AFLOAT *)(y->car))->f );
	if (b == NULL) return NULL;
	p = getCell();
	if (p == NULL) return NULL;
	p->attr = 'n';
	p->car = (CELL *)b;
	return p;
    }
    if (x->attr == 'n' && y->attr == 'b') {
	b = getNumber((long double)(((AINT *)(y->car))->f) / (long double)(((AINT *)(y->cdr))->f) *
		      ((AFLOAT *)(x->car))->f );
	if (b == NULL) return NULL;
	p = getCell();
	if (p == NULL) return NULL;
	p->attr = 'n';
	p->car = (CELL *)b;
	return p;
    }
    if (x->attr == 'b' && y->attr == 'i') {
	if (((AINT *)(y->car))->f == 0L) {
	    a = getInt(0L);
	    p = getCell();
	    p->attr = 'i';
	    p->car = (CELL *)a;
	    return p;
	}
        oldbunshi = ((AINT *)(x->car))->f * ((AINT *)(y->car))->f;
        oldbunbo = ((AINT *)(x->cdr))->f;

        yakubun(oldbunshi,oldbunbo,&bunshi,&bunbo);
	if (bunbo == 1L) {
	    a = getInt(bunshi);
	    if (a == NULL) return NULL;
	    p = getCell();
	    if (p == NULL) return NULL;
	    p->attr = 'i';
	    p->car = (CELL *)a;
	    return p;
	}

	a = getInt(bunshi);
	if (a == NULL) return NULL;
	a2 = getInt(bunbo);
	if (a2 == NULL) return NULL;
	p = getCell();
	if (p == NULL) return NULL;
	p->attr = 'b';
	p->car = (CELL *)a;
	p->cdr = (CELL *)a2;
	return p;
    }
    if (x->attr == 'i' && y->attr == 'b') {
	if (((AINT *)(x->car))->f == 0L) {
	    a = getInt(0L);
	    p = getCell();
	    p->attr = 'i';
	    p->car = (CELL *)a;
	    return p;
	}
        oldbunshi = ((AINT *)(y->car))->f * ((AINT *)(x->car))->f;
        oldbunbo = ((AINT *)(y->cdr))->f;

        yakubun(oldbunshi,oldbunbo,&bunshi,&bunbo);
	if (bunbo == 1L) {
	    a = getInt(bunshi);
	    if (a == NULL) return NULL;
	    p = getCell();
	    if (p == NULL) return NULL;
	    p->attr = 'i';
	    p->car = (CELL *)a;
	    return p;
	}

	a = getInt(bunshi);
	if (a == NULL) return NULL;
	a2 = getInt(bunbo);
	if (a2 == NULL) return NULL;
	p = getCell();
	if (p == NULL) return NULL;
	p->attr = 'b';
	p->car = (CELL *)a;
	p->cdr = (CELL *)a2;
	return p;
    }
    printf("G[: ͐lł͂܂B\n");
    return NULL;
}

CELL *Sho(CELL *x,CELL *y)
{
    AINT *a,*a2;
    CELL *p;
    AFLOAT *b;
    long bunshi,bunbo,oldbunshi,oldbunbo;

    if (x->attr == 'i' && y->attr == 'i') {
	if (((AINT *)(y->car))->f == 0L) { printf("G[: 0ŏZ܂B\n"); return NULL; }
	oldbunshi = ((AINT *)(x->car))->f;
	if (oldbunshi == 0L) {
	    p = getCell();
	    p->attr = 'i';
	    p->car = (CELL *)getInt(0L);
	    return p;
	}
	oldbunbo = ((AINT *)(y->car))->f;
	yakubun(oldbunshi,oldbunbo,&bunshi,&bunbo);
	if (bunbo == 1L) {
	    p = getCell();
	    p->attr = 'i';
	    p->car = (CELL *)getInt(bunshi);
	    return p;
	}
	a = getInt(bunshi);
	a2 = getInt(bunbo);
	p = getCell();
	if (p == NULL) return NULL;
	p->attr = 'b';
	p->car = (CELL *)a;
	p->cdr = (CELL *)a2;
	return p;
    }
    if (x->attr == 'n' && y->attr == 'n') {
	if (((AFLOAT *)(y->car))->f == 0.0) { printf("G[: 0ŏZ܂B\n"); return NULL; }
	b = getNumber(((AFLOAT *)(x->car))->f / ((AFLOAT *)(y->car))->f);
	if (b == NULL) return NULL;
	p = getCell();
	if (p == NULL) return NULL;
	p->attr = 'n';
	p->car = (CELL *)b;
	return p;
    }
    if (x->attr == 'i' && y->attr == 'n') {
	if (((AFLOAT *)(y->car))->f == 0.0) { printf("G[: 0ŏZ܂B\n"); return NULL; }
	if (((AINT *)(x->car))->f == 0L) {
	    a = getInt(0L);
	    p = getCell();
	    p->attr = 'i';
	    p->car = (CELL *)a;
	    return p;
	}
	b = getNumber((long double)(((AINT *)(x->car))->f) / ((AFLOAT *)(y->car))->f);
	if (b == NULL) return NULL;
	p = getCell();
	if (p == NULL) return NULL;
	p->attr = 'n';
	p->car = (CELL *)b;
	return p;
    }
    if (x->attr == 'n' && y->attr == 'i') {
	if (((AINT *)(y->car))->f == 0L) { printf("G[: 0ŏZ܂B\n"); return NULL; }
	b = getNumber(((AFLOAT *)(x->car))->f / (long double)(((AINT *)(y->car))->f));
	if (b == NULL) return NULL;
	p = getCell();
	if (p == NULL) return NULL;
	p->attr = 'n';
	p->car = (CELL *)b;
	return p;
    }
    if (x->attr == 'b' && y->attr == 'b') {
        oldbunshi = ((AINT *)(x->car))->f * ((AINT *)(y->cdr))->f;
        oldbunbo = ((AINT *)(x->cdr))->f * ((AINT *)(y->car))->f;
        yakubun(oldbunshi,oldbunbo,&bunshi,&bunbo);
	if (bunbo == 1L) {
	    a = getInt(bunshi);
	    if (a == NULL) return NULL;
	    p = getCell();
	    if (p == NULL) return NULL;
	    p->attr = 'i';
	    p->car = (CELL *)a;
	    return p;
	}
	a = getInt(bunshi);
	if (a == NULL) return NULL;
	a2 = getInt(bunbo);
	if (a2 == NULL) return NULL;
	p = getCell();
	if (p == NULL) return NULL;
	p->attr = 'b';
	p->car = (CELL *)a;
	p->cdr = (CELL *)a2;
	return p;
    }
    if (x->attr == 'b' && y->attr == 'n') {
	if (((AFLOAT *)(y->car))->f == 0.0) { printf("G[: 0ŏZ܂B\n"); return NULL; }
	b = getNumber((long double)(((AINT *)(x->car))->f) / (long double)(((AINT *)(x->cdr))->f) /
		      ((AFLOAT *)(y->car))->f );
	if (b == NULL) return NULL;
	p = getCell();
	if (p == NULL) return NULL;
	p->attr = 'n';
	p->car = (CELL *)b;
	return p;
    }
    if (x->attr == 'n' && y->attr == 'b') {
	b = getNumber((long double)(((AINT *)(y->cdr))->f) / (long double)(((AINT *)(y->car))->f) *
		      ((AFLOAT *)(x->car))->f );
	if (b == NULL) return NULL;
	p = getCell();
	if (p == NULL) return NULL;
	p->attr = 'n';
	p->car = (CELL *)b;
	return p;
    }
    if (x->attr == 'b' && y->attr == 'i') {
	if (((AINT *)(y->car))->f == 0L) { printf("G[: 0ŏZ܂B\n"); return NULL; }
        oldbunshi = ((AINT *)(x->car))->f;
        oldbunbo = ((AINT *)(x->cdr))->f * ((AINT *)(y->car))->f;

        yakubun(oldbunshi,oldbunbo,&bunshi,&bunbo);
	if (bunbo == 1L) {
	    a = getInt(bunshi);
	    if (a == NULL) return NULL;
	    p = getCell();
	    if (p == NULL) return NULL;
	    p->attr = 'i';
	    p->car = (CELL *)a;
	    return p;
	}

	a = getInt(bunshi);
	if (a == NULL) return NULL;
	a2 = getInt(bunbo);
	if (a2 == NULL) return NULL;
	p = getCell();
	if (p == NULL) return NULL;
	p->attr = 'b';
	p->car = (CELL *)a;
	p->cdr = (CELL *)a2;
	return p;
    }
    if (x->attr == 'i' && y->attr == 'b') {
	if (((AINT *)(x->car))->f == 0L) {
	    a = getInt(0L);
	    p = getCell();
	    p->attr = 'i';
	    p->car = (CELL *)a;
	    return p;
	}
        oldbunshi = ((AINT *)(y->cdr))->f * ((AINT *)(x->car))->f;
        oldbunbo = ((AINT *)(y->car))->f;

        yakubun(oldbunshi,oldbunbo,&bunshi,&bunbo);
	if (bunbo == 1L) {
	    a = getInt(bunshi);
	    if (a == NULL) return NULL;
	    p = getCell();
	    if (p == NULL) return NULL;
	    p->attr = 'i';
	    p->car = (CELL *)a;
	    return p;
	}
/*
	if (bunbo == 1L) {
	    p = getCell();
	    p->attr = 'i';
	    p->car = (CELL *)getInt(bunshi);
	    return p;
	}
*/
	a = getInt(bunshi);
	if (a == NULL) return NULL;
	a2 = getInt(bunbo);
	if (a2 == NULL) return NULL;
	p = getCell();
	if (p == NULL) return NULL;
	p->attr = 'b';
	p->car = (CELL *)a;
	p->cdr = (CELL *)a2;
	return p;
    }
    printf("G[: ͐lł͂܂B\n");
    return NULL;
}

CELL *plus(CELL *s,SYMVAL *loc,long locn)
{
	CELL *k;
	AFLOAT *f;
	CELL *p;
	AINT *a;

        a = getInt(0L);
	if (a == NULL) return NULL;
	k = getCell();
	if (k == NULL) return NULL;
	k->attr = 'i';
	k->car = (CELL *)a;

	for (;;) {
		if (s->attr != 'l') break;

		IncCellStack(NULL);	// Added in Apr.2016
		IncCellStack(k);	// Added in Apr.2016
		IncCellStack(s);

		if ((p = eval(s->car,loc,locn)) == NULL) { PopCellStack(); return NULL; }

		PopCellStack();		// Added in Apr.2016

		k = Wa(k,p);
		if (k == NULL) return NULL;
		s = s->cdr;
	}
	return k;
}

CELL *OnePlus(CELL *s,SYMVAL *loc,long locn)
{
    long k;
    AINT *a,*a2;
    CELL *b;
    long double c;
    AFLOAT *d;
    long bunshi,bunbo;

    s = eval(s,loc,locn);
    if (s == NULL) return NULL;
    if (s->attr == 'i') {
        k = ((AINT *)(s->car))->f + 1;
        a = getInt(k);
        if (a == NULL) return NULL;
        b = getCell();
	if (b == NULL) return NULL;
        b->attr = 'i';
        b->car = (CELL *)a;
        return b;
    }
    if (s->attr == 'n') {
        c = ((AFLOAT *)(s->car))->f + 1.0;
        d = getNumber(c);
        if (d == NULL) return NULL;
        b = getCell();
	if (b == NULL) return NULL;
        b->attr = 'n';
        b->car = (CELL *)d;
        return b;
    }
    if (s->attr == 'b') {
	WaWithTsubun(1,1,((AINT *)(s->car))->f,((AINT *)(s->cdr))->f,&bunshi,&bunbo);
	if (bunbo == 1) {
            a = getInt(bunshi);
            if (a == NULL) return NULL;
	    b = getCell();
 	    if (b == NULL) return NULL;
	    b->attr = 'i';
	    b->car = (CELL *)a;
	    return b;
	}
        a = getInt(bunshi);
        if (a == NULL) return NULL;
        a2 = getInt(bunbo);
        if (a2 == NULL) return NULL;
        b = getCell();
	if (b == NULL) return NULL;
	b->attr = 'b';
	b->car = (CELL *)a;
	b->cdr = (CELL *)a2;
	return b;
    }
    else {
        printf("G[: Ώۂlł͂܂B\n");
        return NULL;
    }
}

CELL *OneMinus(CELL *s,SYMVAL *loc,long locn)
{
    long k;
    AINT *a,*a2;
    CELL *b;
    long double c;
    AFLOAT *d;
    long bunshi,bunbo;

    s = eval(s,loc,locn);
    if (s == NULL) return NULL;
    if (s->attr == 'i') {
        k = ((AINT *)(s->car))->f - 1;
        a = getInt(k);
        if (a == NULL) return NULL;
        b = getCell();
	if (b == NULL) return NULL;
        b->attr = 'i';
        b->car = (CELL *)a;
        return b;
    }
    if (s->attr == 'n') {
        c = ((AFLOAT *)(s->car))->f - 1.0;
        d = getNumber(c);
        if (d == NULL) return NULL;
        b = getCell();
	if (b == NULL) return NULL;
        b->attr = 'n';
        b->car = (CELL *)d;
        return b;
    }
    if (s->attr == 'b') {
	WaWithTsubun(-1,1,((AINT *)(s->car))->f,((AINT *)(s->cdr))->f,&bunshi,&bunbo);
	if (bunbo == 1) {
            a = getInt(bunshi);
            if (a == NULL) return NULL;
	    b = getCell();
 	    if (b == NULL) return NULL;
	    b->attr = 'i';
	    b->car = (CELL *)a;
	    return b;
	}
        a = getInt(bunshi);
        if (a == NULL) return NULL;
        a2 = getInt(bunbo);
        if (a2 == NULL) return NULL;
        b = getCell();
	if (b == NULL) return NULL;
	b->attr = 'b';
	b->car = (CELL *)a;
	b->cdr = (CELL *)a2;
	return b;
    }
    else {
        printf("G[: Ώۂlł͂܂B\n");
        return NULL;
    }
}

CELL *condition(CELL *s,SYMVAL *loc,long locn)
{
	CELL *p,*u;

	for (;;) {
		if (s->attr != 'l') return NILCell;
		u = s->car;
		if (u->attr != 'l') return NILCell;

		IncCellStack(NULL);
		IncCellStack(u);
		IncCellStack(s);

		if ((p = eval(u->car,loc,locn)) == NULL) { PopCellStack(); return NULL; }

		PopCellStack();

		if (p != NILCell) return tprogn(u->cdr,loc,locn);
		s = s->cdr;
	}
}

CELL *tlist(CELL *p,SYMVAL *loc,long locn)
{
	CELL *s,*q,*r,*x;

	if (p->attr != 'l') return NILCell;
	if ((s = getCell()) == NULL) return NULL;
	q = s;
	for (;;) {

		IncCellStack(NULL);	// Added in Apr.2016
		IncCellStack(q);	// Added in Apr.2016

		if ((x = eval(p->car,loc,locn)) == NULL) return NULL;

		PopCellStack();		// Added in Apr.2016

		q->attr = 'l';
		q->car = x;
		p = p->cdr;
		if (p->attr != 'l') { q->cdr = NILCell; return s; }
		if ((r = getCell()) == NULL) return NULL;
		q->cdr = r;
		q = r;
	}
}

CELL *tlist2(CELL *p,SYMVAL *loc,long locn,CELL **u)
{
	CELL *s,*q,*r,*x;
        BOOL First = TRUE;

	if (p->attr != 'l') return NILCell;
	if ((s = getCell()) == NULL) return NULL;
	q = s;
	for (;;) {

		IncCellStack(NULL);
		IncCellStack(q);
		IncCellStack(p);
		if (!First) IncCellStack(*u);

		if ((x = eval(p->car,loc,locn)) == NULL) { PopCellStack(); return NULL; }

		PopCellStack();

                if (First) {
		    *u = x;
		    First = FALSE;
		}
		q->attr = 'l';
		q->car = x;
		p = p->cdr;
		if (p->attr != 'l') { q->cdr = NILCell; return s; }
		if ((r = getCell()) == NULL) return NULL;
		q->cdr = r;
		q = r;
	}
}

CELL *values(CELL *p,SYMVAL *loc,long locn)
{
    CELL *q,*r;

    q = getCell();

    IncCellStack(NULL);
    IncCellStack(q);

    q->mtop = tlist2(p,loc,locn,&r);

    PopCellStack();

    if (q->mtop == NULL) return NULL;
    q->attr = r->attr;
    q->attr2 = r->attr2;
    q->car = r->car;
    q->cdr = r->cdr;
    return q;
}

CELL *IfClause(CELL *p,SYMVAL *loc,long locn)
{
    CELL *q,*r;

    if (p->attr != 'l') goto serror;
    q = p->car;

    IncCellStack(NULL);	// Added in Apr.2016
    IncCellStack(p);	// Added in Apr.2016

    r = eval(q,loc,locn);

    PopCellStack();		// Added in Apr.2016

    if (r == NULL) return NULL;
    p = p->cdr;
    if (r != NILCell) {
        if (p->attr != 'l') goto serror;
        return eval(p->car,loc,locn);
    }
    p = p->cdr;
    if (p->attr != 'l') return NILCell;
    return eval(p->car,loc,locn);

serror:
    printf("G[: @Ⴂ܂B\n");
    return NULL;
}

FILE *getStream(CELL *p)
{
    int a;

    a = (int)(((AINT *)(p->car))->f);
    if (a < 1 || FILE_POINTER_LEN < a) return NULL;
    return FilePointer[a - 1];
}

FILE *getStream2(CELL *p)
{
    int a;
    FILE *fp;

    a = (int)(((AINT *)(p->car))->f);
    if (a < 1 || FILE_POINTER_LEN < a) return NULL;
    fp = FilePointer[a - 1];
    FilePointer[a - 1] = NULL;
    return fp;
}

CELL *tclose(CELL *p,SYMVAL *loc,long locn)
{
    FILE *fp;

    p = eval(p,loc,locn);
    if (p == NULL) return NULL;
    if (p->attr != 'i') goto serror; //return NULL;
    if (p->attr2 != 's') goto serror; //return NULL;
    fp = getStream2(p);
    if (fp == NULL) goto serror; //return NULL;
    fclose(fp);
    return TCell;

serror:
    puts("G[: t@CN[Ył܂");
    return NULL;
}

CELL *tread(CELL *p,SYMVAL *loc,long locn)
{
    CELL *top;
    CELL *q;
    BOOL errmode;
    CELL *ret;
    FILE *fp;
    BOOL owari;

    if (p->attr != 'l') {
        lineStr[0] = '\0';
        if (GetOneS()) {
            SkipTerm(lineStr);
            if (!MakeFunctionText(lineStr,BUFLEN - 1)) return NULL;
            if (!MakeQuoteText(lineStr,BUFLEN - 1)) return NULL;
            if (!MakeBackQuoteText(lineStr,BUFLEN - 1)) return NULL;
            if (!MakeCommaText(lineStr,BUFLEN - 1)) return NULL;
            if (!MakeAstText(lineStr,BUFLEN - 1)) return NULL;
            top = readFromString(lineStr);
            if (top == NULL) return NULL;
	    return top;
        }
        return NULL;
    }
    else {

	IncCellStack(NULL);
	IncCellStack(p);

        q = eval(p->car,loc,locn);

	PopCellStack();

        if (q == NULL) return NULL;
	if (q->attr2 != 's') { puts("G[: Xg[ł͂܂"); return NULL; }
	fp = getStream(q);
	if (fp == NULL) { puts("G[: ̃Xg[͖ł"); return NULL; }
	p = p->cdr;
	if (p->attr != 'l') {
	    errmode = TRUE;
	}
        else {

	    IncCellStack(NULL);
	    IncCellStack(p);

	    q = eval(p->car,loc,locn);

	    PopCellStack();

	    if (q == NULL) return NULL;
	    if (q == NILCell) errmode = FALSE;
	    else errmode = TRUE;
	    p = p->cdr;
            if (p->attr != 'l') ret = NILCell;
            else {
                ret = eval(p->car,loc,locn);
                if (ret == NULL) return NULL;
	    }
	}
        lineStr[0] = '\0';
#if 1
        if (GetOneSStream(fp)) {
	    if (CheckBrace(lineStr) != 1) { printf("G[: ʂ̐܂B\n"); return NULL; } // Add
            SkipTerm(lineStr);
            if (!MakeFunctionText(lineStr,BUFLEN - 1)) return NULL;
            if (!MakeQuoteText(lineStr,BUFLEN - 1)) return NULL;
            if (!MakeBackQuoteText(lineStr,BUFLEN - 1)) return NULL;
            if (!MakeCommaText(lineStr,BUFLEN - 1)) return NULL;
            if (!MakeAstText(lineStr,BUFLEN - 1)) return NULL;
            top = readFromString(lineStr);
            if (top == NULL) return NULL;
	    return top;
        }
#else
	
            owari = GetOneSStream(fp);
            SkipTerm(lineStr);
            if (!MakeFunctionText(lineStr,BUFLEN - 1)) return NULL;
            if (!MakeQuoteText(lineStr,BUFLEN - 1)) return NULL;
            if (!MakeBackQuoteText(lineStr,BUFLEN - 1)) return NULL;
            if (!MakeCommaText(lineStr,BUFLEN - 1)) return NULL;
            if (!MakeAstText(lineStr,BUFLEN - 1)) return NULL;
            top = readFromString(lineStr);
            if (top == NULL) return NULL;
	    return top;
#endif
	if (errmode) {
	    printf("G[: ǂݍݒɃG[𐶂܂B\n");
	    return NULL;
	}
        return ret;
    }
}

CELL *SetFilePointer(FILE *fp)
{
    int i;
    AINT *k;
    CELL *p;

    for (i = 0;i < FILE_POINTER_LEN;i++)
        if (FilePointer[i] == NULL) {
	    if ((p = getCell()) == NULL) return NILCell;
            p->attr = 'i';
	    p->attr2 = 's'; // It is stream.
	    k = getInt((long)(i + 1));
	    p->car = (CELL *)k;
            FilePointer[i] = fp;
	    return p;
        }
    return NILCell;
}

/*
BOOL toPathMojiretsu(char *mr,char *name,int maxlen)
{
    long len;
    char nm[PATH_LEN + 1];

    len = strlen(mr);
    if (*mr != '"') return FALSE;
    if (*(mr + len - 1) != '"') return FALSE;
    len -= 2;
    if (len >= maxlen) return FALSE;
    strcpy(nm,mr + 1);
    nm[len] = '\0';
    strcpy(name,nm);
    return TRUE;
}
*/

/*
CELL *topen(CELL *p,SYMVAL *loc,long locn)
{
    char pathname[PATH_LEN + 1];
    char mode[5];
    FILE *fp;
    CELL *q;

    if (p->attr != 'l') goto serror;
    if ((q = eval(p->car,loc,locn)) == NULL) goto serror;
    if (q->attr != 's' && q->attr != 'r') goto serror;
    if (q->attr == 's') { strncpy(pathname,(char *)(q->car),PATH_LEN); pathname[PATH_LEN] = '\0'; }
    else if (q->attr == 'r') {
	if(!toPathMojiretsu((char *)(q->car),pathname,PATH_LEN)) goto serror;
    }
    p = p->cdr;
    if (p->attr != 'l') {
	strcpy(mode,"rb");
    }
    else if (p->car == COLDIRECTION) {
	p = p->cdr;
        if (p->attr != 'l') strcpy(mode,"rb");
        else {
            q = eval(p->car,loc,locn);
	    if (q == NULL) goto serror;
            if (q == COLINPUT) strcpy(mode,"rb");
	    else if (q == COLOUTPUT) strcpy(mode,"wb");
            else strcpy(mode,"rb");
	}
    }
    else strcpy(mode,"rb");
    fp = fopen(pathname,mode);
    if (fp == NULL) { printf("G[: t@CJƂł܂B\n"); return NILCell; }
    return SetFilePointer(fp);
serror:
    return NILCell;
}
*/

BOOL CheckFunc(CELL *p) // p:(test (x) (print x))
{
    CELL *q;

    if (p->attr != 'l') return FALSE;
    if ((p->car)->attr != 's') return FALSE;
    if ((p->car)->attr2 == 'c') return FALSE;
    p = p->cdr;         // p: ((x) (print x))
    if (p->attr != 'l') return FALSE;
    if (!(p->car == NILCell || (p->car)->attr == 'l')) return FALSE;
    p = p->car;         // p:(x)
    while (p->attr == 'l') {
        q = p->car;
        if (q->attr != 's') return FALSE;
        if (q->attr2 == 'c') return FALSE;
        p = p->cdr;
    }
    return TRUE;
}

CELL *minus(CELL *s,SYMVAL *loc,long locn)
{
	CELL *k;
	CELL *p;

	if (s->attr != 'l') {
		printf("G[: ܂\n");
		return NULL;
	}

	IncCellStack(NULL);
	IncCellStack(s);

	if ((p = eval(s->car,loc,locn)) == NULL) { PopCellStack(); return NULL; }

	PopCellStack();

	if (p->attr != 'n' && p->attr != 'i' && p->attr != 'b') {
		printf("G[: lł͂܂\n");
		return NULL;
	}
	k = p;
	s = s->cdr;
	for (;;) {
		if (s->attr != 'l') break;

		IncCellStack(NULL);	// Added in Apr.2016
		IncCellStack(k);	// Added in Apr.2016
		IncCellStack(s);

		if ((p = eval(s->car,loc,locn)) == NULL) { PopCellStack(); return NULL; }

		PopCellStack();		// Added in Apr.2016

		if ((k = Sa(k,p)) == NULL) return NULL;
		s = s->cdr;
	}
	return k;
}

CELL *times(CELL *s,SYMVAL *loc,long locn)
{
	CELL *k;
	AINT *a;
        AFLOAT *f;
	CELL *p;

	k = getCell();
	k->attr = 'i';
	a = getInt(1L);
	k->car = (CELL *)a;
	for (;;) {
		if (s->attr != 'l') break;

		IncCellStack(NULL);
		IncCellStack(k);
		IncCellStack(s);

		if ((p = eval(s->car,loc,locn)) == NULL) { PopCellStack(); return NULL; }

		PopCellStack();

		if ((k = Seki(k,p)) == NULL) return NULL;
		s = s->cdr;
	}
	return k;
}

CELL *divide(CELL *s,SYMVAL *loc,long locn)
{
	CELL *k;
	AFLOAT *f;
	CELL *p;

	if (s->attr != 'l') {
		printf("G[: ܂\n");
		return NULL;
	}

	IncCellStack(NULL);
	IncCellStack(s);

	if ((p = eval(s->car,loc,locn)) == NULL) { PopCellStack(); return NULL; }

	PopCellStack();

	if (p->attr != 'n' && p->attr != 'i' && p->attr != 'b') {
		printf("G[: lł͂܂\n");
		return NULL;
	}
	k = p;
	s = s->cdr;
	for (;;) {
		if (s->attr != 'l') break;

		IncCellStack(NULL);
		IncCellStack(s);
		IncCellStack(k);

		if ((p = eval(s->car,loc,locn)) == NULL) { PopCellStack(); return NULL; }

		PopCellStack();

		k = Sho(k,p);
		if (k == NULL) return NULL;
		s = s->cdr;
	}
	return k;
}

CELL *minusp(CELL *s)
{
	if (s == NULL) return NULL;
	switch (s->attr) {
	    case 'i':
		if (((AINT *)(s->car))->f < 0L) return TCell;
		else return NILCell;
	    case 'b':
		if (((AINT *)(s->car))->f < 0L) return TCell;
		else return NILCell;
	    case 'n':
		if (((AFLOAT *)(s->car))->f < 0.0) return TCell;
		else return NILCell;
	    default:
		printf("G[: lł͂܂\n");
		return NULL;
	}
}

/*
CELL *tchar(CELL *p,SYMVAL *loc,long locn)
{
    CELL *q,*r;
    long k,i,len;
    long cnt;
    char *ch;

    if (p->attr != 'l') goto serror;
    q = p->car;
    q = eval(q,loc,locn);
    if (q == NULL) return NULL;
    p = p->cdr;
    if (p->attr != 'l') goto serror;
    r = p->car;
    r = eval(r,loc,locn);
    if (r == NULL) return NULL;
    if (q->attr != 'r') goto serror;
    if (r->attr != 'i') goto serror;
    k = ((AINT *)(r->car))->f;
    cnt = 0;
    len = strlen((char *)(q->car));
    len -= 2;
    ch = (char *)(q->car) + 1;
    for (i = 0;i < len;i++) {
	if (cnt == k) {
	    if (isKanji(ch)) {
		return getMojiCell(*ch,*(ch + 1));
	    }
	    else if (*ch == '\\' && *(ch + 1) == '"') return getMojiCell(*(ch + 1),NULL);
	    else if (*ch == '\\' && *(ch + 1) == '\\') return getMojiCell(*(ch + 1),NULL);
	    else return getMojiCell(*ch,NULL);
	}
        if (*ch == '\\' && *(ch + 1) == '"') {
	    cnt++; i++; ch += 2;
	}
        else if (*ch == '\\' && *(ch + 1) == '\\') {
	    cnt++; i++; ch += 2;
	}
	else if (isKanji(ch)) {
	    cnt++; i++; ch += 2;
	}
	else { cnt++; ch++; }
    }
serror:
    printf("G[: @ԈĂ܂B\n");
    return NULL;
}
*/

CELL *jlength(CELL *p)
{
    CELL *q;
    AINT *k;
    long i,len,cnt;
    char *ch;

    if (p->attr == 'l' || p == NILCell) {
  jlengthlist:
	q = getCell();
	if (q == NULL) return NULL;
	k = getInt(tlength(p));
	if (k == NULL) return NULL;
	q->attr = 'i';
	q->car = (CELL *)k;
	return q;
    }
    if (p->attr == 'a') {
	if ((p->car)->attr != 'i') { puts("G[: z񂪉Ă܂"); return NULL; }
	if (((AINT *)((p->car)->car))->f != 1) { puts("G[: ꎟzł͂܂"); return NULL; }
	if ((p->cdr)->attr != 'l') { puts("G[: z񂪉Ă܂"); return NULL; }
	p = p->cdr->cdr;
	goto jlengthlist;
    }
    if (p->attr == 'r') {
	len = strlen((char *)(p->car)) - 2;
	cnt = 0;
	ch = (char *)(p->car) + 1;
	for (i = 0;i < len;i++) {
	    if (*ch == '\\' && *(ch + 1) == '\"') {
		ch += 2;
		i++;
		cnt++;
	    }
	    else if (*ch == '\\' && *(ch + 1) == '\\') {
		ch += 2;
		i++;
		cnt++;
	    }
	    else if (isKanji(ch)) {
		ch += 2;
		i++;
		cnt++;
	    }
	    else { ch++; cnt++; }
	}
	q = getCell();
	if (q == NULL) return NULL;
	k = getInt(cnt);
	if (k == NULL) return NULL;
	q->attr = 'i';
	q->car = (CELL *)k;
	return q;
    }
    printf("G[: Ώۂ̓XgłȂĂ͂Ȃ܂B\n");
    return NULL;
}

long getRealMojiretsuLen(CELL *p)
{
    long k = 0;
    CELL *q;
    char ch;

    while (p->attr == 'l') {
	q = p->car;
	if (q->attr != 'm') return -1L;
	ch = (char)(q->car);
	if (isKanji(&ch)) k += 2;
	else if (ch == '\\') k += 2;
	else if (ch == '"') k += 2;
	else k++;
	p = p->cdr;
    }
    return k;
}

CELL *BunkaiMojiretsu(char *s)
{
    CELL *q;

    if (*s == '"') return NILCell;
    if (*s == '\\' && *(s + 1) == '\\') {
	q = getCell();

	IncCellStack(NULL);
	IncCellStack(q);

	q->attr = 'l';
	q->car = getMojiCell('\\',NULL);
        q->cdr = BunkaiMojiretsu(s + 2);

	PopCellStack();

	return q;
    }
    if (*s == '\\' && *(s + 1) == '"') {
	q = getCell();

	IncCellStack(NULL);
	IncCellStack(q);

	q->attr = 'l';
	q->car = getMojiCell('"',NULL);
        q->cdr = BunkaiMojiretsu(s + 2);

	PopCellStack();

	return q;
    }
    if (isKanji(s)) {
	q = getCell();

	IncCellStack(NULL);
	IncCellStack(q);

	q->attr = 'l';
	q->car = getMojiCell(*s,*(s + 1));
        q->cdr = BunkaiMojiretsu(s + 2);

	PopCellStack();

	return q;
    }
    else {
	q = getCell();

	IncCellStack(NULL);
	IncCellStack(q);

	q->attr = 'l';
	q->car = getMojiCell(*s,NULL);
        q->cdr = BunkaiMojiretsu(s + 1);

	PopCellStack();

	return q;
    }
}

/*
CELL *coerce(CELL *p,SYMVAL *loc,long locn)
{
    CELL *x,*y,*q;
    char *buf,*org;
    long len;
    char ch;
    char *s;

    if (p->attr != 'l') goto serror;
    x = p->car;
    x = eval(x,loc,locn);
    if (x == NULL) return NULL;
    p = p->cdr;
    if (p->attr != 'l') goto serror;
    y = p->car;
    y = eval(y,loc,locn);
    if (y == NULL) return NULL;
    if (y == STRING) {
        if (x->attr != 'l' && x != NILCell) goto serror;
	len = getRealMojiretsuLen(x);
	if (len < 0) goto serror;
	len += 3;
	org = buf = (char *)malloc(len);
	*buf++ = '"';
	for (;;) {
	    if (x->attr != 'l') break;
	    q = x->car;
	    ch = (char)(q->car);
	    if (isKanji(&ch)) { *buf++ = ch; *buf++ = (char)(q->cdr); }
	    else if (ch == '\\') { *buf++ = '\\'; *buf++ = '\\'; }
	    else if (ch == '"') { *buf++ = '\\'; *buf++ = '"'; }
	    else *buf++ = ch;
	    x = x->cdr;
        }
	*buf++ = '"';
	*buf = '\0';
	q = getMojiretsuCell(org);
	free(org);
        if (q == NULL) return NULL;
	return q;
    }
    else if (y == LIST) {
	if (x->attr != 'r') goto serror;
	s = (char *)(x->car);
	s++;
        return BunkaiMojiretsu(s);
    }
    else if (y == FUNCTION) return x;

serror:
    printf("G[: COERCE: @ԈĂ܂B\n");
    return NULL;
}
*/

/*
CELL *ReadLine(void)
{
    char *p;
    CELL *q,*r,*r2;

    fgets(lineStr + 1,BUFLEN - 1,stdin);
    p = lineStr;
    *p++ = '"';
    while (*p != '\0') {
	if (*p == '\n') { *p = '\0'; break; }
	else if (*p == '\\') { p++; slide(p,1); *p++ = '\\'; }
	else if (*p == '"') { *p++ = '\\'; slide(p,1); *p++ = '"'; }
	else if (isKanji(p)) { p += 2; }
	else p++;
    }
    strcat(lineStr,"\"");
    q = getMojiretsuCell(lineStr);
    r = getCell();
    r2 = getCell();
    r->attr = 'l';
    r->car = q;
    r->cdr = r2;
    r2->attr = 'l';
    r2->car = NILCell;
    r2->cdr = NILCell;
    q->mtop = r;
    return q;
}
*/

CELL *ReadLineStrm(FILE *fp)
{
    char *p;
    CELL *q,*r,*r2;
    BOOL flag = TRUE;

    if (fgets(lineStr + 1,BUFLEN - 1,fp) == NULL) {
	strcpy(lineStr,"\"\"");
        q = getMojiretsuCell(lineStr);
        r = getCell();
        r2 = getCell();
        r->attr = 'l';
        r->car = q;
        r->cdr = r2;
        r2->attr = 'l';
        r2->car = TCell;
        r2->cdr = NILCell;
        q->mtop = r;
        return q;
    }
    p = lineStr;
    *p++ = '"';
    while (*p != '\0') {
	if (*p == '\n') { *p = '\0'; flag = FALSE; break; }
	else if (*p == '\r') { *p = '\0'; flag = FALSE; break; }
	else if (*p == '\\') { p++; slide(p,1); *p++ = '\\'; }
	else if (*p == '"') { *p++ = '\\'; slide(p,1); *p++ = '"'; }
	else if (isKanji(p)) { p += 2; }
	else {
	    p++;
	}
    }
    strcat(lineStr,"\"");
    q = getMojiretsuCell(lineStr);
    r = getCell();
    r2 = getCell();
    r->attr = 'l';
    r->car = q;
    r->cdr = r2;
    r2->attr = 'l';
    if (flag) r2->car = TCell;
    else r2->car = NILCell;
    r2->cdr = NILCell;
    q->mtop = r;
    return q;
}

CELL *MakeQuoteEach(CELL *p)
{
    CELL *q,*r,*s;

    if (p->attr != 'l') return NILCell;
    q = getCell();
    q->attr = 'l';
    q->car = QUOTE;
    r = getCell();
    r->attr = 'l';
    q->cdr = r;
    r->car = p->car;
    r->cdr = NILCell;
    s = getCell();
    s->attr = 'l';
    s->car = q;
    s->cdr = MakeQuoteEach(p->cdr);
    return s;
}

CELL *apply(CELL *x,CELL *y,SYMVAL *loc,long locn)
{
	CELL *tp,*z,*p,*r,*q,*d,*e;
	long len,i,j,len2;
	SYMVAL *temploc,*lc;

	IncCellStack(NULL);
	IncCellStack(y);

	if ((x = eval(x->car,loc,locn)) == NULL) { PopCellStack(); return NULL; }

	PopCellStack();

	if (y->attr != 'l') y = NILCell;
	else {

		IncCellStack(NULL);
		IncCellStack(x);

		if ((y = eval(y->car,loc,locn)) == NULL) { PopCellStack(); return NULL; }

		PopCellStack();

	}
        tp = MakeQuoteEach(y);
	if (x->attr == 's') {
		if ((r = getCell()) == NULL) return NULL;
		r->attr = 'l';
		r->car = x;
		r->cdr = tp;
		return eval(r,loc,locn);
	}
	else if (x->attr == 'l' && (x->car)->attr == 's' && x->car == LAMBDA) {
		if ((x->cdr)->attr != 'l') { printf("G[: @G[\n"); return NULL; }
		len = tlength((x->cdr)->car);
		len2 = x->cljlen;
		if (len + /*locn +*/ len2 != 0L) {
		    temploc = (SYMVAL *)calloc(len + /*locn +*/ len2,sizeof(SYMVAL));
		    if (temploc == NULL) {
			printf("G[: [Jϐ̈̊mۂɎs܂\n");
			return NULL;
		    }
		}
		else temploc = NULL;

		IncCellStack(NULL);		// Add in Apr.2016
		IncCellStack(x);		// Add in Apr.2016

		if (!initTemploc(temploc,len,(x->cdr)->car,tp,loc,locn)) {
			printf("G[: ܂\n");
			free(temploc);
			PopCellStack();
			return NULL;
		}

		PopCellStack();			// Add in Apr.2016

		locn = 0L; // Added on 2014.3.1

		for (i = len,j = 0;i < len + locn;i++,j++) {
			temploc[i].attr = loc[j].attr;
			temploc[i].sym = loc[j].sym;
			temploc[i].val = loc[j].val;
		}

		lc = x->clj;
		for (i = len + locn,j = 0;i < len + locn + len2;i++,j++) {
			temploc[i].attr = lc[j].attr;
			temploc[i].sym = lc[j].sym;
			temploc[i].val = lc[j].val;
		}

/* Deleted in Apr.2016
		IncCellStack(NULL);
*/
		if (IncLocStack(temploc,len + locn + len2) == -1) {
		    free(temploc);
		    return NULL;
		}

		IncCellStack(NULL);		// Add in Apr.2016
		IncCellStack(x);		// Add in Apr.2016

		p = tprogn((x->cdr)->cdr,temploc,len + locn + len2);

		PopCellStack();			// Add in Apr.2016

		PopLocStack();
/* Deleted in Apr.2016
		PopCellStack();
		if (p != NULL) IncCellStack(p);
*/
		SetOrgLoc(x->clj,x->cljlen,temploc,len + locn,len + locn + len2);
		/*SetOrgLoc(loc,locn,temploc,len,len + locn); Deleted on 2014.3.1 */
		free(temploc);
		return p;
	}
	printf("G[: APPLY̌ĂяoԈĂ܂\n");
	return NULL;
}

CELL *funcall(CELL *x,CELL *y,SYMVAL *loc,long locn)
{
	CELL *tp,*z,*p,*r,*q,*d,*e;
	long len,i,j,len2;
	SYMVAL *temploc,*lc;

	IncCellStack(NULL);
	IncCellStack(y);

	if ((x = eval(x->car,loc,locn)) == NULL) { PopCellStack(); return NULL; }

	PopCellStack();

	if (x->attr == 's') {
		if ((r = getCell()) == NULL) return NULL;
		r->attr = 'l';
		r->car = x;
		r->cdr = y;
		return eval(r,loc,locn);
	}
	else if (x->attr == 'l' && (x->car)->attr == 's' && x->car == LAMBDA) {
		if ((x->cdr)->attr != 'l') { printf("G[: @G[\n"); return NULL; }
		len = tlength((x->cdr)->car);
		len2 = x->cljlen;
		if (len + /*locn +*/ len2 != 0L) {
		    temploc = (SYMVAL *)calloc(len + /*locn +*/ len2,sizeof(SYMVAL));
		    if (temploc == NULL) {
			printf("G[: [Jϐ̈̊mۂɎs܂\n");
			return NULL;
		    }
		}
		else temploc = NULL;

		IncCellStack(NULL);		// Add in Apr.2016
		IncCellStack(x);		// Add in Apr.2016

		if (!initTemploc(temploc,len,(x->cdr)->car,y,loc,locn)) {
			printf("G[: ܂\n");
			free(temploc);
			PopCellStack();
			return NULL;
		}

		PopCellStack();			// Add in Apr.2016

		locn = 0L;  // Added on 2014.3.1

		for (i = len,j = 0;i < len + locn;i++,j++) {
			temploc[i].attr = loc[j].attr;
			temploc[i].sym = loc[j].sym;
			temploc[i].val = loc[j].val;
		}

		lc = x->clj;
		for (i = len + locn,j = 0;i < len + locn + len2;i++,j++) {
			temploc[i].attr = lc[j].attr;
			temploc[i].sym = lc[j].sym;
			temploc[i].val = lc[j].val;
		}

/* Deleted in Apr.2016
		IncCellStack(NULL);
*/
		if (IncLocStack(temploc,len + locn + len2) == -1) {
		    free(temploc);
		    return NULL;
		}

		IncCellStack(NULL);		// Add in Apr.2016
		IncCellStack(x);		// Add in Apr.2016

		p = tprogn((x->cdr)->cdr,temploc,len + locn + len2);

		PopCellStack();			// Add in Apr.2016

		PopLocStack();
/* Deleted in Apr.2016
		PopCellStack();
		if (p != NULL) IncCellStack(p);
*/
		SetOrgLoc(x->clj,x->cljlen,temploc,len + locn,len + locn + len2);
		/*SetOrgLoc(loc,locn,temploc,len,len + locn); Deleted on 2014.3.1 */
		free(temploc);
		return p;
	}
	printf("G[: FUNCALĽĂяoԈĂ܂\n");
	return NULL;
}

CELL *rplaca(CELL *x,CELL *y)
{
    if (x->attr != 'l') { printf("G[: RXł͂܂\n"); return NULL; }
    x->car = y;
    return x;
}

CELL *rplacd(CELL *x,CELL *y)
{
    if (x->attr != 'l') { printf("G[: RXł͂܂\n"); return NULL; }
    x->cdr = y;
    return x;
}

/*
CELL *SubstExcept(CELL *p,CELL *e,SYMVAL *loc,long locn)
{
    long n;
    CELL *q,*q2;

    if (p->attr != 'l') {
	if (tmember(p,e) != NILCell) {
	    return p;
	}
	else if ((n = getLocal(loc,locn,p)) != -1) {
	    return loc[n].val;
	}
	else if ((n = getSymVal(p)) != -1) {
	    return (sv + n)->val;
	}
	else return p;
    }
    else if (p->car == QUOTE || p->car == BACKQUOTE) {
	return p;
    }
    else if (p->car == SETQ) {
	if ((p->cdr)->attr == 'l' && ((p->cdr)->cdr)->attr == 'l') {
	    q = getCell();
	    q->attr = 'l';
	    q->car = p->car;
	    q2 = getCell();
	    q2->attr = 'l';
	    q->cdr = q2;
	    q2->car = (p->cdr)->car;
	    q2->cdr = SubstExcept((p->cdr)->cdr,e,loc,locn);
	    return q;
	}
	else return NILCell;
    }
    else {
	q = getCell();
	q->attr = 'l';
	q->car = SubstExcept(p->car,e,loc,locn);
	q->cdr = SubstExcept(p->cdr,e,loc,locn);
	return q;
    }
}
*/
#if 0
CELL *function(CELL *p,SYMVAL *loc,long locn)
{
    CELL *q1,*q2;

    if (p->attr == 's') return p;
    if (p->attr == 'l' && p->car == LAMBDA && (p->cdr)->attr == 'l' &&
        ((p->cdr)->car == NILCell || ((p->cdr)->car)->attr == 'l') ) {
	q1 = getCell();
	q1->attr = 'l';
	q1->car = LAMBDA;
	q2 = getCell();
	q2->attr = 'l';
	q1->cdr = q2;
	q2->car = (p->cdr)->car;
	q2->cdr = SubstExcept((p->cdr)->cdr,(p->cdr)->car,loc,locn);
	return q1;
    }
    printf("G[: FUNCTION̎gԈĂ܂\n");
    return NULL;
}
#else
CELL *function(CELL *p,SYMVAL *loc,long locn)
{
    CELL *q1,*q2;

    if (p->attr == 's') return p;
    if (p->attr == 'l' && p->car == LAMBDA && (p->cdr)->attr == 'l' &&
        ((p->cdr)->car == NILCell || ((p->cdr)->car)->attr == 'l') ) {
        p->clj = loc;
	p->cljlen = locn;
	return p;
    }
    printf("G[: FUNCTION̎gԈĂ܂\n");
    return NULL;
}
#endif

CELL *evalu(CELL *top,SYMVAL *loc,long locn,BOOL *multi)
{
	CELL *p,*x,*y,*z;
	long n2;
	SYMVAL *r,*temploc;
	long len,i;
	long mi,ni;
	char ch,ch2;
	char *xc,*yc;
	FILE *fp;
#if 0
        AFLOAT *n;
	int col;
	AFLOAT *k;
	DWORD Millisec;
#endif
	if (FreeCellSize < CELL_SIZE_MIN || FreeNumberSize < NUMBER_SIZE_MIN ||
	    FreeIntSize < INT_SIZE_MIN /*|| curMojiretsu - mojiretsuArea > MOJIRETSU_SIZE - MOJIRETSU_SIZE_MIN*/ ) {
            gc();
	}
//printS(top);
//printf("\n");
	*multi = FALSE;
	if (top->attr == 'l') {
		if ((top->car)->attr != 's') {
			if ((top->car)->attr == 'l' && (top->car)->car == LAMBDA) {
				*multi = TRUE;
				x = getCell();
				y = getCell();
				z = getCell();
				p = getCell();
				z->attr = 'l';
				y->attr = 'l';
				x->attr = 'l';
				p->attr = 'l';
				p->car = FUNCALL;
				p->cdr = x;
				x->cdr = top->cdr;
				x->car = y;
				y->car = FUNCTION;
				y->cdr = z;
				z->car = top->car;
				z->cdr = NILCell;
				return eval(p,loc,locn);
			}
			goto serror;
		}
		else {
                        if (top->car == QUOTE) {
				if ((top->cdr)->attr != 'l') goto serror;
				return (top->cdr)->car;
			}
			else if (top->car == CAR) {
				if ((top->cdr)->attr != 'l') goto serror;
				if ((top = eval((top->cdr)->car,loc,locn)) == NULL) return NULL;
				if (top->attr != 'l') goto serror;
				return top->car;
			}
			else if (top->car == CDR) {
				if ((top->cdr)->attr != 'l') goto serror;
				if ((top = eval((top->cdr)->car,loc,locn)) == NULL) return NULL;
				if (top->attr != 'l') goto serror;
				return top->cdr;
			}
			else if (top->car == CONS) {
				if ((top->cdr)->attr != 'l') goto serror;
				if (((top->cdr)->cdr)->attr != 'l') goto serror;
				if ((p = getCell()) == NULL) return NULL;
				p->attr = 'l';

				IncCellStack(NULL);
				IncCellStack(top);
				IncCellStack(p);

				if ((p->car = eval((top->cdr)->car,loc,locn)) == NULL) { PopCellStack(); return NULL; }
				if ((p->cdr = eval(((top->cdr)->cdr)->car,loc,locn)) == NULL) { PopCellStack(); return NULL; }

				PopCellStack();

				return p;
			}
			else if (top->car == BACKQUOTE) {
//                                if ((top->cdr)->attr != 'l') goto serror;
                                return backquote(top->cdr,loc,locn);
			}
			else if (top->car == PRINT) {
				if ((top->cdr)->attr != 'l') goto serror;

				IncCellStack(NULL);
				IncCellStack(top);

				if ((p = eval((top->cdr)->car,loc,locn)) == NULL) { PopCellStack(); return NULL; }

				PopCellStack();

				if (((top->cdr)->cdr)->attr == 'l') {

				    IncCellStack(NULL);
				    IncCellStack(p);

				    if ((y = eval(((top->cdr)->cdr)->car,loc,locn)) == NULL) { PopCellStack(); return NULL; }

				    PopCellStack();

				    if (y->attr2 != 's') goto serror;
				    if ((fp = getStream(y)) == NULL) goto serror;
				    fprintf(fp,"\r\n");
				    printSStrm(p,fp);
				    fprintf(fp," ");
				}
				else {
                    		    printf("\n");
                                    printS(p);
				    printf(" ");
				}
				return p;
			}
			else if (top->car == PRIN1) {
				if ((top->cdr)->attr != 'l') goto serror;

				IncCellStack(NULL);
				IncCellStack(top);

				if ((p = eval((top->cdr)->car,loc,locn)) == NULL) { PopCellStack(); return NULL; }

				PopCellStack();

				if (((top->cdr)->cdr)->attr == 'l') {

				    IncCellStack(NULL);
				    IncCellStack(p);

				    if ((y = eval(((top->cdr)->cdr)->car,loc,locn)) == NULL) { PopCellStack(); return NULL; }

				    PopCellStack();

				    if (y->attr2 != 's') goto serror;
				    if ((fp = getStream(y)) == NULL) goto serror;
				    printSStrm(p,fp);
				}
				else {
                                    printS(p);
				}
				return p;
			}
			else if (top->car == PRINC) {
				if ((top->cdr)->attr != 'l') goto serror;

				IncCellStack(NULL);
				IncCellStack(top);

				if ((p = eval((top->cdr)->car,loc,locn)) == NULL) { PopCellStack(); return NULL; }

				PopCellStack();

				if (((top->cdr)->cdr)->attr == 'l') {

				    IncCellStack(NULL);
				    IncCellStack(p);

				    if ((y = eval(((top->cdr)->cdr)->car,loc,locn)) == NULL) { PopCellStack(); return NULL; }

				    PopCellStack();

				    if (y->attr2 != 's') goto serror;
				    if ((fp = getStream(y)) == NULL) goto serror;
				    princS(p,fp);
				}
				else {
                                    princS(p,stdout);
				}
				return p;
			}
			else if (top->car == SET) {
				if ((top->cdr)->attr != 'l') goto serror;
				if (((top->cdr)->cdr)->attr != 'l') goto serror;

				IncCellStack(NULL);
				IncCellStack(top);

				if ((x = eval((top->cdr)->car,loc,locn)) == NULL) { PopCellStack(); return NULL; }

				PopCellStack();

				IncCellStack(NULL);
				IncCellStack(x);

				if ((y = eval(((top->cdr)->cdr)->car,loc,locn)) == NULL) { PopCellStack(); return NULL; }

				PopCellStack();

				if (x->attr != 's') goto serror;
				if (x->attr2 == 'c') goto serror;
				if ((n2 = getSymVal2(x)) == -1) return NULL;
				sv[n2].sym = x;
				sv[n2].val = y;
				return y;
			}
			else if (top->car == DEFPARAMETER) {
				if ((top->cdr)->attr != 'l') goto serror;
				if (((top->cdr)->cdr)->attr != 'l') goto serror;
				x = (top->cdr)->car;

				IncCellStack(NULL);
				IncCellStack(x);

				if ((y = eval(((top->cdr)->cdr)->car,loc,locn)) == NULL) { PopCellStack(); return NULL; }

				PopCellStack();

				if (x->attr != 's') goto serror;
				if (x->attr2 == 'c') goto serror;
				if ((n2 = getSymVal2(x)) == -1) return NULL;
				y->mtop = NULL;
				sv[n2].sym = x;
				sv[n2].val = y;
				return x;
			}
			else if (top->car == DEFVAR) {
				if ((top->cdr)->attr != 'l') goto serror;
				if (((top->cdr)->cdr)->attr != 'l') goto serror;
				x = (top->cdr)->car;

				IncCellStack(NULL);
				IncCellStack(x);

				if ((y = eval(((top->cdr)->cdr)->car,loc,locn)) == NULL) { PopCellStack(); return NULL; }

				PopCellStack();

				if (x->attr != 's') goto serror;
				if (x->attr2 == 'c') goto serror;
				if (getSymVal(x) != -1) return x;
				if ((n2 = getSymVal2(x)) == -1) return NULL;
				y->mtop = NULL;
				sv[n2].sym = x;
				sv[n2].val = y;
				return x;
			}
			else if (top->car == SETQ) {
				if ((top->cdr)->attr != 'l') goto serror;
				if (((top->cdr)->cdr)->attr != 'l') goto serror;
	setq:
				x = (top->cdr)->car;
				if (x->attr2 == 'c') goto serror;

				IncCellStack(NULL);	// Added in Apr.2016
				IncCellStack(x);	// Added in Apr.2016

				if ((y = eval(((top->cdr)->cdr)->car,loc,locn)) == NULL) return NULL;

				PopCellStack();		// Added in Apr.2016

				if (x->attr != 's') goto serror;
				if ((n2 = getLocal(loc,locn,x)) != -1) {
					loc[n2].val = y;
					return y;
				}
				else {
					if ((n2 = getSymVal2(x)) == -1) return NULL;
					sv[n2].sym = x;
					sv[n2].val = y;
					return y;
				}
			}
			else if (top->car == AND) {
				return tand(top->cdr,loc,locn);
			}
			else if (top->car == OR) {
				return tor(top->cdr,loc,locn);
			}
			else if (top->car == ONEPLUS) {
				if ((top->cdr)->attr != 'l') goto serror;
				return OnePlus((top->cdr)->car,loc,locn);
			}
			else if (top->car == ONEMINUS) {
				if ((top->cdr)->attr != 'l') goto serror;
				return OneMinus((top->cdr)->car,loc,locn);
			}
			else if (top->car == ATOM) {
				if ((top->cdr)->attr != 'l') goto serror;
		                if ((p = eval((top->cdr)->car,loc,locn)) == NULL) return NULL;
				if (p->attr != 'l') return TCell;
				else return NILCell;
			}
			else if (top->car == CONSP) {
				if ((top->cdr)->attr != 'l') goto serror;
		                if ((p = eval((top->cdr)->car,loc,locn)) == NULL) return NULL;
				if (p->attr == 'l') return TCell;
				else return NILCell;
			}
			else if (top->car == NUMBERP) {
				if ((top->cdr)->attr != 'l') goto serror;
                		if ((p = eval((top->cdr)->car,loc,locn)) == NULL) return NULL;
				if (p->attr == 'i' || p->attr == 'n' || p->attr == 'b' ) return TCell;
				else return NILCell;
			}
			else if (top->car == INTEGERP) {
				if ((top->cdr)->attr != 'l') goto serror;
                		if ((p = eval((top->cdr)->car,loc,locn)) == NULL) return NULL;
				if (p->attr == 'i') return TCell;
				else return NILCell;
			}
			else if (top->car == EVAL) {
				if ((top->cdr)->attr != 'l') goto serror;

				IncCellStack(NULL);
				IncCellStack(top);

                		if ((p = eval((top->cdr)->car,loc,locn)) == NULL) { PopCellStack(); return NULL; }

				PopCellStack();

				p = eval(p,loc,locn);
				return p;
			}
			else if (top->car == TIMES) {
				p = times(top->cdr,loc,locn);
				return p;
			}
			else if (top->car == PLUS) {
				p = plus(top->cdr,loc,locn);
				return p;
			}
			else if (top->car == MINUS) {
				p = minus(top->cdr,loc,locn);
				return p;
			}
			else if (top->car == DIVIDE) {
				p = divide(top->cdr,loc,locn);
				return p;
			}
			else if (top->car == NUMBEREQUAL) {
				if ((top->cdr)->attr != 'l') goto serror;
				if (((top->cdr)->cdr)->attr != 'l') goto serror;

				IncCellStack(NULL);
				IncCellStack(top);

				if ((x = eval((top->cdr)->car,loc,locn)) == NULL) { PopCellStack(); return NULL; }

				PopCellStack();

				IncCellStack(NULL);
				IncCellStack(x);

				if ((y = eval(((top->cdr)->cdr)->car,loc,locn)) == NULL) { PopCellStack(); return NULL; }

				PopCellStack();

				if (x->attr == 'n' && y->attr == 'n') {
				    if (((AFLOAT *)(x->car))->f == ((AFLOAT *)(y->car))->f) return TCell;
				    return NILCell;
                                }
				if (x->attr == 'i' && y->attr == 'i') {
				    if (((AINT *)(x->car))->f == ((AINT *)(y->car))->f) return TCell;
				    return NILCell;
                                }
				if (x->attr == 'i' && y->attr == 'n') {
				    if (((long double)(((AINT *)(x->car))->f)) ==
                                        ((AFLOAT *)(y->car))->f ) return TCell;
				    return NILCell;
                                }
				if (x->attr == 'n' && y->attr == 'i') {
				    if (((AFLOAT *)(x->car))->f ==
                                        ((long double)(((AINT *)(y->car))->f)) ) return TCell;
				    return NILCell;
                                }
				if (x->attr == 'b' && y->attr == 'b') {
				    if (((AINT *)(x->car))->f !=
					((AINT *)(y->car))->f ) return NILCell;
				    if (((AINT *)(x->cdr))->f !=
					((AINT *)(y->cdr))->f ) return NILCell;
				    return TCell;
				}
				if (x->attr == 'b' && y->attr == 'n') {
				    mi = ((AINT *)(x->car))->f;
				    ni = ((AINT *)(x->cdr))->f;
				    if ((long double)mi / (long double)ni == ((AFLOAT *)(y->car))->f) return TCell;
				    return NILCell;
                                }
				if (x->attr == 'n' && y->attr == 'b') {
				    mi = ((AINT *)(y->car))->f;
				    ni = ((AINT *)(y->cdr))->f;
				    if ((long double)mi / (long double)ni == ((AFLOAT *)(x->car))->f) return TCell;
				    return NILCell;
                                }
				if (x->attr == 'b' && y->attr == 'i') return NILCell;  // 2015/3/26
				if (x->attr == 'i' && y->attr == 'b') return NILCell;  // 2015/3/26
                                goto serror;
			}
			else if (top->car == EQ) {
				if ((top->cdr)->attr != 'l') goto serror;
				if (((top->cdr)->cdr)->attr != 'l') goto serror;

				IncCellStack(NULL);
				IncCellStack(top);

				if ((x = eval((top->cdr)->car,loc,locn)) == NULL) { PopCellStack(); return NULL; }

				PopCellStack();

				IncCellStack(NULL);
				IncCellStack(x);

				if ((y = eval(((top->cdr)->cdr)->car,loc,locn)) == NULL) { PopCellStack(); return NULL; }

				PopCellStack();

				if (x->attr == 's') {
					if (y->attr != 's') return NILCell;
					if (x == y) return TCell;
					return NILCell;
				}
				else if (x->attr == 'i') {
					if (y->attr != 'i') return NILCell;
					if (((AINT *)(x->car))->f == ((AINT *)(y->car))->f) return TCell;
					return NILCell;
				}
				else if (x->attr == 'l' || x->attr == 'a') {
					if (x == y) return TCell;
					return NILCell;
				}
				return NILCell;
			}
			else if (top->car == EQL) {
			    if ((top->cdr)->attr != 'l') goto serror;
			    x = (top->cdr)->car;
			    if (((top->cdr)->cdr)->attr != 'l') goto serror;
			    y = ((top->cdr)->cdr)->car;

			    IncCellStack(NULL);
			    IncCellStack(y);

			    x = eval(x,loc,locn);

			    PopCellStack();

			    if (x == NULL) return NULL;

			    IncCellStack(NULL);
			    IncCellStack(x);

			    y = eval(y,loc,locn);

			    PopCellStack();

			    if (y == NULL) return NULL;
			    if (x == y) return TCell;
			    if (x->attr == 'i' && y->attr == 'i') {
				if (((AINT *)(x->car))->f == ((AINT *)(y->car))->f) return TCell;
				else return NILCell;
			    }
			    if (x->attr == 'n' && y->attr == 'n') {
				if (((AFLOAT *)(x->car))->f == ((AFLOAT *)(y->car))->f) return TCell;
				else return NILCell;
			    }
			    if (x->attr == 'b' && y->attr == 'b') {
				if (((AINT *)(x->car))->f == ((AINT *)(y->car))->f
				    && ((AINT *)(x->cdr))->f == ((AINT *)(y->cdr))->f )
				    return TCell;
				else return NILCell;
			    }
			    if (x->attr == 'm' && y->attr == 'm') {
				if (x->cdr == NULL && y->cdr == NULL) {
				    if ((unsigned char)(x->car) == (unsigned char)(y->car)) return TCell;
				    else return NILCell;
				}
				if (x->cdr == NULL || y->cdr == NULL) return NILCell;
				if ((unsigned char)(x->car) == (unsigned char)(y->car) &&
				    (unsigned char)(x->cdr) == (unsigned char)(y->cdr) ) return TCell;
				return NILCell;
			    }
			    return NILCell;
			}
			else if (top->car == NULLP) {
				if ((top->cdr)->attr != 'l') goto serror;
				if ((p = eval((top->cdr)->car,loc,locn)) == NULL) return NULL;
				if (p == NILCell) return TCell;
				return NILCell;
			}
			else if (top->car == PROGN) {
				*multi = TRUE;
				p = tprogn(top->cdr,loc,locn);
				return p;
			}
			else if (top->car == PROG1) {
				*multi = TRUE;
				p = tprog1(top->cdr,loc,locn);
				return p;
			}
			else if (top->car == MINUSP) {
				if ((top->cdr)->attr != 'l') goto serror;
				return minusp(eval((top->cdr)->car,loc,locn));
			}
			else if (top->car == COND) {
				*multi = TRUE;
				p = condition(top->cdr,loc,locn);
				return p;
			}
			else if (top->car == IF) {
				*multi = TRUE;
				p = IfClause(top->cdr,loc,locn);
				return p;
			}
#if 0
			else if (!lstrcmp((TCHAR *)((top->car)->car),TEXT("loop"))) {
				return loopBody(top->cdr,loc,locn);
			}
			else if (!lstrcmp((TCHAR *)((top->car)->car),TEXT("load"))) {
				if ((top->cdr)->attr != 'l') goto serror;
				if (!(top = eval((top->cdr)->car,loc,locn))) return NULL;
				if (top->attr != 's') goto serror;
				return load((TCHAR *)(top->car),loc,locn);
			}
			else if (!lstrcmp((LPCWSTR)(TCHAR *)((top->car)->car),TEXT("random"))) {
				if ((top->cdr)->attr != 'l') goto serror;
				if (!(top = eval((top->cdr)->car,loc,locn))) return NULL;
				return trandom(top);
			}
			else if (!lstrcmp((TCHAR *)((top->car)->car),TEXT("sqrt"))) {
				if ((top->cdr)->attr != 'l') goto serror;
				if (!(top = eval((top->cdr)->car,loc,locn))) return NULL;
				return tsqrt(top);
			}
			else if (!lstrcmp((TCHAR *)((top->car)->car),TEXT("xwidth"))) {
				return xwidth();
			}
			else if (!lstrcmp((TCHAR *)((top->car)->car),TEXT("ywidth"))) {
				return ywidth();
			}
			else if (!lstrcmp((TCHAR *)((top->car)->car),TEXT("xcenter"))) {
				return xcenter();
			}
			else if (!lstrcmp((TCHAR *)((top->car)->car),TEXT("ycenter"))) {
				return ycenter();
			}
			else if (!lstrcmp((TCHAR *)((top->car)->car),TEXT("cs"))) {
				return tcs();
			}
			else if (!lstrcmp((LPCWSTR)(TCHAR *)((top->car)->car),TEXT("setpc"))) {
				if ((top->cdr)->attr != 'l') goto serror;
				if (!(top = eval((top->cdr)->car,loc,locn))) return NULL;
				if (top->attr != 'n') goto serror;
				col = (int)(((AFLOAT *)(top->car))->f);
				switch (col) {
				    case 0: SelectObject(ghdc,hPenL); SelectObject(memdc,hPenL); break;
				    case 1: SelectObject(ghdc,hPen1); SelectObject(memdc,hPen1); break;
				    case 2: SelectObject(ghdc,hPen2); SelectObject(memdc,hPen2); break;
				    case 3: SelectObject(ghdc,hPen3); SelectObject(memdc,hPen3); break;
				    case 4: SelectObject(ghdc,hPen4); SelectObject(memdc,hPen4); break;
				    case 5: SelectObject(ghdc,hPen5); SelectObject(memdc,hPen5); break;
				    case 6: SelectObject(ghdc,hPen6); SelectObject(memdc,hPen6); break;
				    case 7: SelectObject(ghdc,hPen7); SelectObject(memdc,hPen7); break;
					default: goto serror;
				}
				penColor = col;
				return TCell;
			}
			else if (!lstrcmp((TCHAR *)((top->car)->car),TEXT("setf"))) {
				if ((top->cdr)->attr != 'l') goto serror;
				if (((top->cdr)->cdr)->attr != 'l') goto serror;
                		if (((top->cdr)->car)->attr == 's') goto setq;
				return setf(top->cdr,(top->cdr)->cdr,loc,locn);
			}
			else if (!lstrcmp((TCHAR *)((top->car)->car),TEXT("putd"))) {
				if ((top->cdr)->attr != 'l') goto serror;
				if (((top->cdr)->cdr)->attr != 'l') goto serror;
				if (!(x = eval((top->cdr)->car,loc,locn))) return NULL;
				if (!(y = eval(((top->cdr)->cdr)->car,loc,locn))) return NULL;
				if (y->attr != 'l') goto serror;  // y : (lambda (x) (print x))
				y = y->cdr;
				if (y->attr != 'l') goto serror;  // y : ((x) (print x))
				if (x->attr != 's') goto serror;
				if (!(r = getFuncval((TCHAR *)(x->car)))) return NULL;
				if (!(r->sym = getString((TCHAR *)(x->car)))) return NULL;
				r->val = y;
				return TCell;
			}
			else if (!lstrcmp((TCHAR *)((top->car)->car),TEXT("gethash"))) {
				if ((top->cdr)->attr != 'l') goto serror;
				if (((top->cdr)->cdr)->attr != 'l') goto serror;
				return gethash(top->cdr,(top->cdr)->cdr,loc,locn);
			}
			else if (!lstrcmp((TCHAR *)((top->car)->car),TEXT("remhash"))) {
				if ((top->cdr)->attr != 'l') goto serror;
				if (((top->cdr)->cdr)->attr != 'l') goto serror;
				return remhash(top->cdr,(top->cdr)->cdr,loc,locn);
			}
			else if (!lstrcmp((TCHAR *)((top->car)->car),TEXT("make-hash-table"))) {
				return MakeHashTable();
			}
#endif
			else if (top->car == DEFUN) {
				if (!CheckFunc(top->cdr)) goto serror;
				if ((top->cdr)->attr != 'l') goto serror;
				if (((top->cdr)->cdr)->attr != 'l') goto serror;
				if ((r = getFuncval((top->cdr)->car)) == NULL) return NULL;
				if ( ( r->sym = getStringCell( (char *)(((top->cdr)->car)->car) ) ) == NULL)
                                    return NULL;
				r->val = (top->cdr)->cdr;
				r->attr = 'f';
				return r->sym;
			}
			else if (top->car == DEFMACRO) {
				if (!CheckFunc(top->cdr)) goto serror;
				if ((top->cdr)->attr != 'l') goto serror;
				if (((top->cdr)->cdr)->attr != 'l') goto serror;
				if ((r = getFuncval((top->cdr)->car)) == NULL) return NULL;
				if ( ( r->sym = getStringCell( (char *)(((top->cdr)->car)->car) ) ) == NULL)
                                    return NULL;
				r->val = (top->cdr)->cdr;
				r->attr = 'm';
				return r->sym;
			}
			else if (top->car == LET) { *multi = TRUE; p = Let(top->cdr,loc,locn); return p; }
			else if (top->car == LETAST) { *multi = TRUE; p = LetAst(top->cdr,loc,locn); return p; }
                        else if (top->car == PROG) {
				*multi = TRUE; p = prog(top->cdr,loc,locn); return p;
			}
			else if (top->car == GO) {
                            if ((top->cdr)->attr != 'l') goto serror;
			    if (((top->cdr)->car)->attr != 's') goto serror;
                            GoSymbol = (top->cdr)->car;
                            return TCell;
                        }
			else if (top->car == RETURN) {
                            if ((top->cdr)->attr != 'l') {
			        ReturnValue = NILCell;
                                ReturnFlag = 'a';
                                return NILCell;
                            }
                            x = eval((top->cdr)->car,loc,locn);
                            if (x == NULL) return NULL;
			    ReturnValue = x;
                            ReturnFlag = 'a';
			    *multi = TRUE;
                            return x;
                        }
#if 0
			else if (!lstrcmp((TCHAR *)((top->car)->car),TEXT("funcall"))) {
				if ((top->cdr)->attr != 'l') goto serror;
				return funcall(top->cdr,(top->cdr)->cdr,loc,locn);
			}
#endif
			else if (top->car == APPLY) {
				*multi = TRUE;
				if ((top->cdr)->attr != 'l') goto serror;
				return apply(top->cdr,(top->cdr)->cdr,loc,locn);
			}
			else if (top->car == FUNCALL) {
				*multi = TRUE;
				if ((top->cdr)->attr != 'l') goto serror;
				return funcall(top->cdr,(top->cdr)->cdr,loc,locn);
			}
#if 0
			else if (!lstrcmp((TCHAR *)((top->car)->car),TEXT("sleep"))) {
				if ((top->cdr)->attr != 'l') goto serror;
				if (!(top = eval((top->cdr)->car,loc,locn))) return NULL;
				if (top->attr != 'n') goto serror;
				Millisec = (DWORD)(((AFLOAT *)(top->car))->f);
				Sleep(Millisec);
				return TCell;
			}
			else if (!lstrcmp((TCHAR *)((top->car)->car),TEXT("printout"))) {
				if ((top->cdr)->attr != 'l') goto serror;
				if (((top->cdr)->cdr)->attr != 'l') goto serror;
				if (!(linesCell = eval((top->cdr)->car,loc,locn))) return NULL;
				if (!(circlesCell = eval(((top->cdr)->cdr)->car,loc,locn))) return NULL;
				SendMessage(hwnd,WM_COMMAND,MAKEWPARAM(IDM_PRINTOUT,0),0);
				if (LineCircle) return TCell;
				else return NILCell;
			}

			else if (!lstrcmp((TCHAR *)((top->car)->car),TEXT("writelc"))) {
				if ((top->cdr)->attr != 'l') goto serror;
				if (((top->cdr)->cdr)->attr != 'l') goto serror;
				if ((((top->cdr)->cdr)->cdr)->attr != 'l') goto serror;
				if (!(linesCell = eval((top->cdr)->car,loc,locn))) return NULL;
				if (!(circlesCell = eval(((top->cdr)->cdr)->car,loc,locn))) return NULL;
				if (!(filenameCell = eval((((top->cdr)->cdr)->cdr)->car,loc,locn))) return NULL;
				SendMessage(hwnd,WM_COMMAND,MAKEWPARAM(IDM_WRITE,0),0);
				if (LineCircle) return TCell;
				else return NILCell;
			}
			else if (!lstrcmp((TCHAR *)((top->car)->car),TEXT("readlc"))) {
				if ((top->cdr)->attr != 'l') goto serror;
				if (!(filenameCell = eval((top->cdr)->car,loc,locn))) return NULL;
				SendMessage(hwnd,WM_COMMAND,MAKEWPARAM(IDM_READ,0),0);
				return returnCell;
			}

#endif
			else if (top->car == LIST) {
				p = tlist(top->cdr,loc,locn);
				return p;
			}
			else if (top->car == TOPEN) {
				p = topen(top->cdr,loc,locn);
				return p;
			}
			else if (top->car == TCLOSE) {
				if ((top->cdr)->attr != 'l') goto serror;
				return tclose((top->cdr)->car,loc,locn);
			}
			else if (top->car == TREAD) {
				return tread(top->cdr,loc,locn);
			}
			else if (top->car == CHAR) {
				p = tchar(top->cdr,loc,locn);
				return p;
			}
			else if (top->car == STRINGP) {
				if ((top->cdr)->attr != 'l') goto serror;
				x = eval((top->cdr)->car,loc,locn);
				if (x == NULL) return NULL;
				if (x->attr == 'a' && (x->car)->attr == 'i' && ((AINT *)((x->car)->car))->f == 1L &&
				    (x->cdr)->car == CHARACTER )
				    return TCell;
				return NILCell;
			}
			else if (top->car == LENGTH) {
				if ((top->cdr)->attr != 'l') goto serror;
				x = eval((top->cdr)->car,loc,locn);
				if (x == NULL) return NULL;
				return jlength(x);
			}
			else if (top->car == COERCE) {
				return coerce(top->cdr,loc,locn);
			}
			else if (top->car == FUNCTION) {
				if ((top->cdr)->attr != 'l') goto serror;
#if 0
				if (((top->cdr)->car)->attr == 'l' && ((top->cdr)->car)->car == LAMBDA)
				    return (top->cdr)->car;
				if (((top->cdr)->car)->attr == 's') return (top->cdr)->car;
				goto serror;
#else
				return function((top->cdr)->car,loc,locn);
#endif
			}
			else if (top->car == SPACES) {
				if ((top->cdr)->attr != 'l') goto serror;

				IncCellStack(NULL);
				IncCellStack(top);

				x = eval((top->cdr)->car,loc,locn);

				PopCellStack();

				if (x == NULL) return NULL;
				if (x->attr != 'i') goto serror;
				len = ((AINT *)(x->car))->f;
				if (len < 0) goto serror;
				if (((top->cdr)->cdr)->attr != 'l') {
				    for (i = 0;i < len;i++) printf(" ");
                                }
				else {
				    if ((y = eval(((top->cdr)->cdr)->car,loc,locn)) == NULL) return NULL;
				    if (y->attr2 != 's') goto serror;
				    if ((fp = getStream(y)) == NULL) goto serror;
				    for (i = 0;i < len;i++) fprintf(fp," ");
				}
				return TCell;
			}
			else if (top->car == TERPRI) {
				if ((top->cdr)->attr != 'l') {
				    fp = stdout;
                                }
				else {
				    if ((y = eval((top->cdr)->car,loc,locn)) == NULL) return NULL;
				    if (y->attr2 != 's') goto serror;
				    if ((fp = getStream(y)) == NULL) goto serror;
				}
				if (fp != stdout) fprintf(fp,"\r");
				fprintf(fp,"\n");
				return TCell;
			}
			else if (top->car == STRINGEQUAL) {
				if ((top->cdr)->attr != 'l') goto serror;

				IncCellStack(NULL);
				IncCellStack(top);

				x = eval((top->cdr)->car,loc,locn);

				PopCellStack();

				if (x == NULL) return NULL;
//				if (x->attr != 'r') goto serror;
				if (((top->cdr)->cdr)->attr != 'l') goto serror;

				IncCellStack(NULL);
				IncCellStack(x);

				y = eval(((top->cdr)->cdr)->car,loc,locn);

				PopCellStack();

				if (y == NULL) return NULL;
				return StringEqual(x,y);
/*
				if (y->attr != 'r') goto serror;
				xc = (char *)(x->car);
				yc = (char *)(y->car);
				while (*xc != '\0')
				    if (*xc++ != *yc++) return NILCell;
				if (*yc != '\0') return NILCell;
				return TCell;
*/
			}
			else if (top->car == CHAREQUAL) {
				if ((top->cdr)->attr != 'l') goto serror;

				IncCellStack(NULL);
				IncCellStack(top);

				x = eval((top->cdr)->car,loc,locn);

				PopCellStack();

				if (x == NULL) return NULL;
				if (x->attr != 'm') goto serror;
				if (((top->cdr)->cdr)->attr != 'l') goto serror;

				IncCellStack(NULL);
				IncCellStack(x);

				y = eval(((top->cdr)->cdr)->car,loc,locn);

				PopCellStack();

				if (y == NULL) return NULL;
				if (y->attr != 'm') goto serror;
				if (x->cdr == NULL && y->cdr == NULL) {
				    if ((unsigned char)(x->car) == (unsigned char)(y->car)) return TCell;
				    else return NILCell;
				}
				if (x->cdr == NULL || y->cdr == NULL) return NILCell;
				if ((unsigned char)(x->car) == (unsigned char)(y->car) &&
				    (unsigned char)(x->cdr) == (unsigned char)(y->cdr) ) return TCell;
				return NILCell;
			}
			else if (top->car == CHARLESS) {
				if ((top->cdr)->attr != 'l') goto serror;

				IncCellStack(NULL);
				IncCellStack(top);

				x = eval((top->cdr)->car,loc,locn);

				PopCellStack();

				if (x == NULL) return NULL;
				if (x->attr != 'm') goto serror;
				if (((top->cdr)->cdr)->attr != 'l') goto serror;

				IncCellStack(NULL);
				IncCellStack(x);

				y = eval(((top->cdr)->cdr)->car,loc,locn);

				PopCellStack();

				if (y == NULL) return NULL;
				if (y->attr != 'm') goto serror;
				if (x->cdr == NULL && y->cdr == NULL) {
				    if ((unsigned char)(x->car) < (unsigned char)(y->car)) return TCell;
				    else return NILCell;
				}
				if (x->cdr == NULL) return TCell;
				if (y->cdr == NULL) return NILCell;
				if ((unsigned char)(x->car) < (unsigned char)(y->car)) return TCell;
				if ((unsigned char)(x->car) != (unsigned char)(y->car)) return NILCell;
				if ((unsigned char)(x->cdr) < (unsigned char)(y->cdr)) return TCell;
				return NILCell;
			}
			else if (top->car == GC) {
				gc();
				return TCell;
			}
			else if (top->car == MULTIPLEVALUELIST) {
				if ((top->cdr)->attr != 'l') goto serror;
				if ((x = eval((top->cdr)->car,loc,locn)) == NULL) return NULL;
				if (x->mtop == NULL) {
					p =getCell();
					p->attr = 'l';
					p->car = x;
					p->cdr = NILCell;
					return p;
				}
				else {
					return x->mtop;
				}
			}
			else if (top->car == RPLACA) {
				if ((top->cdr)->attr != 'l') goto serror;
				if (((top->cdr)->cdr)->attr != 'l') goto serror;

				IncCellStack(NULL);
				IncCellStack(top);

				x = eval((top->cdr)->car,loc,locn);

				PopCellStack();

				if (x == NULL) return NULL;

				IncCellStack(NULL);
				IncCellStack(x);

				y = eval(((top->cdr)->cdr)->car,loc,locn);

				PopCellStack();

				if (y == NULL) return NULL;
				return rplaca(x,y);
			}
			else if (top->car == RPLACD) {
				if ((top->cdr)->attr != 'l') goto serror;
				if (((top->cdr)->cdr)->attr != 'l') goto serror;

				IncCellStack(NULL);
				IncCellStack(top);

				x = eval((top->cdr)->car,loc,locn);

				PopCellStack();

				if (x == NULL) return NULL;

				IncCellStack(NULL);
				IncCellStack(x);

				y = eval(((top->cdr)->cdr)->car,loc,locn);

				PopCellStack();

				if (y == NULL) return NULL;
				return rplacd(x,y);
			}
			else if (top->car == SYMBOLP) {
				if ((top->cdr)->attr != 'l') goto serror;
				x = eval((top->cdr)->car,loc,locn);
				if (x == NULL) return NULL;
				if (x->attr == 's') return TCell;
				return NILCell;
			}
			else if (top->car == CHARACTERP) {
				if ((top->cdr)->attr != 'l') goto serror;
				x = eval((top->cdr)->car,loc,locn);
				if (x == NULL) return NULL;
				if (x->attr == 'm') return TCell;
				return NILCell;
			}
			else if (top->car == BYE || top->car == QUIT || top->car == EXIT) {
				exit(0);
			}
			else if (top->car == MACROEXPAND) {
			    if ((top->cdr)->attr != 'l') goto serror;
			    top = eval((top->cdr)->car,loc,locn);
			    if (top == NULL) return NULL;
			    r = getFuncval2(top->car);
			    if (r == NULL || r->attr != 'm') {
				printf("G[: `̃}Nł\n");
				return NULL;
			    }
			    return MacroExec2(top->cdr,r,loc,locn);
			}

			else if (top->car == SETARRAY) {
				return SetArray(top,loc,locn);
			}
		/*	else if (top->car == AREF) {
				return aref(top,loc,locn);
			}*/
		/*	else if (top->car == PREAREF) {
				return prearef(top,loc,locn);
			}*/
			else if (top->car == ARRAYCAR) {
			    if ((top->cdr)->attr != 'l') goto serror;
			    top = eval((top->cdr)->car,loc,locn);
			    if (top == NULL) return NULL;
			    return ArrayCar(top);
			}
			else if (top->car == ARRAYCDR) {
			    if ((top->cdr)->attr != 'l') goto serror;
			    top = eval((top->cdr)->car,loc,locn);
			    if (top == NULL) return NULL;
			    return ArrayCdr(top);
			}
			else if (top->car == ARRAYP) {
				if ((top->cdr)->attr != 'l') goto serror;
				x = eval((top->cdr)->car,loc,locn);
				if (x == NULL) return NULL;
				if (x->attr == 'a') return TCell;
				return NILCell;
			}
			else if (top->car == RANDOM) {
				if ((top->cdr)->attr != 'l') goto serror;
				return Random((top->cdr)->car,loc,locn);
			}
			else if (top->car == SQRT) {
				if ((top->cdr)->attr != 'l') goto serror;
				return jSqrt((top->cdr)->car,loc,locn);
			}
			else if (top->car == EXPT) {
				if ((top->cdr)->attr != 'l') goto serror;
				if (((top->cdr)->cdr)->attr != 'l') goto serror;
				return jExpt((top->cdr)->car,((top->cdr)->cdr)->car,loc,locn);
			}
			else if (top->car == EXP) {
				if ((top->cdr)->attr != 'l') goto serror;
				return jExp((top->cdr)->car,loc,locn);
			}
			else if (top->car == LOG) {
				if ((top->cdr)->attr != 'l') goto serror;
				return jLog((top->cdr)->car,loc,locn);
			}
			else if (top->car == SIN) {
				if ((top->cdr)->attr != 'l') goto serror;
				return jSin((top->cdr)->car,loc,locn);
			}
			else if (top->car == COS) {
				if ((top->cdr)->attr != 'l') goto serror;
				return jCos((top->cdr)->car,loc,locn);
			}
			else if (top->car == TAN) {
				if ((top->cdr)->attr != 'l') goto serror;
				return jTan((top->cdr)->car,loc,locn);
			}
			else if (top->car == ASIN) {
				if ((top->cdr)->attr != 'l') goto serror;
				return jAsin((top->cdr)->car,loc,locn);
			}
			else if (top->car == ACOS) {
				if ((top->cdr)->attr != 'l') goto serror;
				return jAcos((top->cdr)->car,loc,locn);
			}
			else if (top->car == ATAN) {
				if ((top->cdr)->attr != 'l') goto serror;
				return jAtan((top->cdr)->car,loc,locn);
			}
			else if (top->car == EVENP) {
				if ((top->cdr)->attr != 'l') goto serror;
				return jEvenp((top->cdr)->car,loc,locn);
			}
			else if (top->car == FLOOR) {
				if ((top->cdr)->attr != 'l') goto serror;
				p = tfloor((top->cdr)->car,loc,locn);
				if (p == NULL) return NULL;
				*multi = TRUE;
				return p;
			}

			else {
				*multi = TRUE;
				r = getFuncval2(top->car);
				if (r == NULL) {
					printf("G[: `̊֐܂̓}Nł\n");
					return NULL;
				}
				if (r->attr == 'm') {
				    return MacroExec(top->cdr,r,loc,locn);
				}
				len = tlength((r->val)->car);
                                if (len != 0) {
				    temploc = (SYMVAL *)calloc(len,sizeof(SYMVAL));
				    if (temploc == NULL) {
					printf("G[: [Jϐ̈̊mۂɎs܂\n");
					return NULL;
				    }
                                }
                                else temploc = NULL;
				if (!initTemploc(temploc,len,(r->val)->car,top->cdr,loc,locn)) {
					printf("G[: ̐Ⴂ܂\n");
					free(temploc);
					return NULL;
				}

/*
			    if (IncLocStack(NULL,1) == -1) {
				    free(temploc);
				    return NULL;
			    }
			    if (IncLocStack(temploc,len) == -1) {
				    free(temploc);
				    return NULL;
			    }
				if (FreeCellSize < CELL_SIZE_MIN || FreeNumberSize < NUMBER_SIZE_MIN) gc();
*/
/* Deleted in Apr.2016
				IncCellStack(NULL);
*/
				IncLocStack(temploc,len);
				p = tprogn((r->val)->cdr,temploc,len);
				PopLocStack();
/* Deleted in Apr.2016
				PopCellStack();
				if (p != NULL) IncCellStack(p);
*/
/*
			        while (*(--curLocStack) != NULL);
			        while (*(--curCellStack) != NULL);
*/
				free(temploc);
				return p;
			}
		}
	}
	else if (top->attr == 'n' || top->attr == 'i' || top->attr == 'b' ||
                 top->attr == 'r' || top->attr == 'm' || top->attr == 'a' ) { *multi = TRUE; return top; }
        else if (top->attr2 == 'c') return top;
	else if ((n2 = getLocal(loc,locn,top)) != -1) {
		*multi = TRUE;
		return loc[n2].val;
	}
	else {
		*multi = TRUE;
		n2 = getSymVal(top);
		if (n2 == -1) {
			printf("G[: ̕ϐɂ͑Ă܂\n");
			return NULL;
		}
                return (sv + n2)->val;
	}
serror:
	printf("G[: @G[\n");
	return NULL;
}

CELL *eval(CELL *top,SYMVAL *loc,long locn)
{
	CELL *p;
	FILE *fp;
	BOOL multi;

	if (top->car == VALUES) {
	    return values(top->cdr,loc,locn);
	}
	else if (top->car == READLINE) {
	    if ((top->cdr)->attr != 'l') return ReadLine();
	    p = eval((top->cdr)->car,loc,locn);
	    if (p->attr2 != 's') { puts("G[: Xg[ł͂܂"); return NULL; }
	    fp = getStream(p);
	    if (fp == NULL) { puts("G[: ȃXg[ł"); return NULL; }
            return ReadLineStrm(fp);
	}
	else if (top->car == EVAL1) {
	    if ((top->cdr)->attr != 'l') goto serror;
            if ((p = eval((top->cdr)->car,loc,locn)) == NULL) return NULL;
	    p = eval(p,loc,locn);
	    return p;
	}
	p = evalu(top,loc,locn,&multi);
	if (p != NULL && !multi) p->mtop = NULL;
	return p;
serror:
	printf("G[: @Ⴂ܂B\n");
	return NULL;
}

void MultiPrintS(CELL *mtop)
{
    while (mtop->attr == 'l') {
	printS(mtop->car);
	if ((mtop->cdr)->attr == 'l') printf(" ;\n");
	else printf("\n");
	mtop = mtop->cdr;
    }
}

void ReadEvalPrintLoop(void)
{
    CELL *top;
    int i = 1;

    for (;;) {
        printf("[%d]",i++);
        lineStr[0] = '\0';
        if (GetOneS()) {
            SkipTerm(lineStr);
            if (!MakeFunctionText(lineStr,BUFLEN - 1)) break;
            if (!MakeQuoteText(lineStr,BUFLEN - 1)) break;
            if (!MakeBackQuoteText(lineStr,BUFLEN - 1)) break;
            if (!MakeCommaText(lineStr,BUFLEN - 1)) break;
            if (!MakeAstText(lineStr,BUFLEN - 1)) break;
            top = readFromString(lineStr);
            if (top == NULL) break;

	    IncCellStack(NULL);
	    IncCellStack(top);

            top = eval(top,NULL,0);

	    PopCellStack();

            if (top != NULL) {
                if (top->mtop == NULL) { printS(top); printf("\n"); }
                else MultiPrintS(top->mtop);
	    }
//            DumpString();
        }
    }
}

BOOL ReadEvalLoop(void)
{
    CELL *top;
    int i;

    for (i = 0;i < READ_EVAL_NUM;i++) {
            strcpy(lineStr,ReadEvalData[i]);
            SkipTerm(lineStr);
            if (!MakeFunctionText(lineStr,BUFLEN - 1)) return NULL;
            if (!MakeQuoteText(lineStr,BUFLEN - 1)) return FALSE;
            if (!MakeBackQuoteText(lineStr,BUFLEN - 1)) return FALSE;
            if (!MakeCommaText(lineStr,BUFLEN - 1)) return FALSE;
            if (!MakeAstText(lineStr,BUFLEN - 1)) return FALSE;
//            printf("%s\n",lineStr);
            top = readFromString(lineStr);
            if (top == NULL) return FALSE;

	    IncCellStack(NULL);
	    IncCellStack(top);

            top = eval(top,NULL,0);

	    PopCellStack();

            if (top == NULL) return FALSE;
    }
    return TRUE;
}

void SetKeyword(void)
{
    long n2;

    QUOTE = getStringCell("QUOTE");
    CAR = getStringCell("CAR");
    CDR = getStringCell("CDR");
    CONS = getStringCell("CONS");
    PRINT = getStringCell("PRINT");
    PRIN1 = getStringCell("PRIN1");
    SET = getStringCell("SET");

    NILCell = getStringCell("NIL");
    TCell = getStringCell("T");

    NIL = getStringCell("NIL");
    n2 = getSymVal2(NIL);
    sv[n2].sym = NIL;
    sv[n2].val = NILCell;

    T = getStringCell("T");
    n2 = getSymVal2(T);
    sv[n2].sym = T;
    sv[n2].val = TCell;

    BACKQUOTE = getStringCell("BACKQUOTE");
    BACK_QUOTE = getStringCell("`");
    COMMA = getStringCell(",");
    AST = getStringCell("@");

    DEFUN = getStringCell("DEFUN");
    AMPREST = getStringCell("&REST");
    LET = getStringCell("LET");
    LETAST = getStringCell("LET*");
    SETQ = getStringCell("SETQ");
    PROG = getStringCell("PROG");
    GO = getStringCell("GO");
    RETURN = getStringCell("RETURN");

//    Dummy = getCell();
//    Dummy->returnflag = 'u';
    AND = getStringCell("AND");
    OR = getStringCell("OR");
    ONEPLUS = getStringCell("1+");
    ONEMINUS = getStringCell("1-");
    COND = getStringCell("COND");
    NUMBEREQUAL = getStringCell("=");
    DEFMACRO = getStringCell("DEFMACRO");
    AMPBODY = getStringCell("&BODY");
    ATOM = getStringCell("ATOM");
    LIST = getStringCell("LIST");
    EQ = getStringCell("EQ");
    EVAL = getStringCell("EVAL");
    NULLP = getStringCell("NULL");
    PROGN = getStringCell("PROGN");
    IF = getStringCell("IF");
    TREAD = getStringCell("READ");
    TOPEN = getStringCell("OPEN");
    COLDIRECTION = getStringCell(":DIRECTION");
    COLINPUT = getStringCell(":INPUT");
    COLOUTPUT = getStringCell(":OUTPUT");
    TCLOSE = getStringCell("CLOSE");
    PROG1 = getStringCell("PROG1");
    PLUS = getStringCell("+");
    MINUS = getStringCell("-");
    MINUSP = getStringCell("MINUSP");
    EQL = getStringCell("EQL");
    CHAR = getStringCell("CHAR");
    STRINGP = getStringCell("STRINGP");
    LENGTH = getStringCell("LENGTH");
    COERCE = getStringCell("COERCE");
    STRING = getStringCell("STRING");
    PRINC = getStringCell("PRINC");
    FUNCTION = getStringCell("FUNCTION");
    LAMBDA = getStringCell("LAMBDA");
    SPACES = getStringCell("SPACES");
    TERPRI = getStringCell("TERPRI");
    STRINGEQUAL = getStringCell("STRING-EQUAL");
    READLINE = getStringCell("READ-LINE");
    GC = getStringCell("GC");
    BYE = getStringCell("BYE");
    QUIT = getStringCell("QUIT");
    EXIT = getStringCell("EXIT");
    DEFPARAMETER = getStringCell("DEFPARAMETER");
    DEFVAR = getStringCell("DEFVAR");
    CONSP = getStringCell("CONSP");
    NUMBERP = getStringCell("NUMBERP");
    TIMES = getStringCell("*");
    DIVIDE = getStringCell("/");
    VALUES = getStringCell("VALUES");
    MULTIPLEVALUELIST = getStringCell("MULTIPLE-VALUE-LIST");
    EVAL1 = getStringCell("EVAL1");
    APPLY = getStringCell("APPLY");
    FUNCALL = getStringCell("FUNCALL");
    RPLACA = getStringCell("RPLACA");
    RPLACD = getStringCell("RPLACD");
    SYMBOLP = getStringCell("SYMBOLP");
    CHARACTERP = getStringCell("CHARACTERP");
    CHAREQUAL = getStringCell("CHAR-EQUAL");
    CHARLESS = getStringCell("CHAR<");
    MACROEXPAND = getStringCell("MACROEXPAND");

    INTEGERP = getStringCell("INTEGERP");
    SETARRAY = getStringCell("SET-ARRAY");
//    AREF = getStringCell("AREF");
//    PREAREF = getStringCell("PREAREF");
    CHARACTER = getStringCell("CHARACTER");
    ARRAYCAR = getStringCell("ARRAY-CAR");
    ARRAYCDR = getStringCell("ARRAY-CDR");
    ARRAYP = getStringCell("ARRAYP");

    RANDOM = getStringCell("RANDOM");

    SQRT = getStringCell("SQRT");
    EXPT = getStringCell("EXPT");
    EXP = getStringCell("EXP");
    LOG = getStringCell("LOG");
    SIN = getStringCell("SIN");
    COS = getStringCell("COS");
    TAN = getStringCell("TAN");
    ASIN = getStringCell("ASIN");
    ACOS = getStringCell("ACOS");
    ATAN = getStringCell("ATAN");

    EVENP = getStringCell("EVENP");
    FLOOR = getStringCell("FLOOR");
}

int main(void)
{
//    long i = 0L;
//    for (;;) { printf("%ld\n",i); i += 10000L; }
//    long double a = 0.000000000000345;
//    printf("%Le %Lf %Lg\n",a,a,a);
//    printf("%s\n",ReadEvalData[0]);

    if (!AllocMemory()) return 1;
    IncCellStack(NULL);
    IncLocStack(NULL,0);
    SetKeyword();
    if (!ReadEvalLoop()) return 1;
    printf("jpnslisp {Lisp vesion2.11\nCopyright(c) 2014-2016 rr\n");
    ReadEvalPrintLoop();
    return 0;
}
